/*
 *   -- micMAGMA (version 1.4.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      @date July 2015
 *
 * @generated from magma_zc.h mixed zc -> ds, Sun Jul 12 17:46:24 2015
 */

#ifndef _MAGMA_DS_H_
#define _MAGMA_DS_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Mixed precision */
magma_int_t magma_dsgesv_mic(  magma_trans_t trans, magma_int_t N, magma_int_t NRHS,
                               magmaDouble_ptr dA, size_t dA_offset, magma_int_t ldda,
                               magma_int_t *IPIV, magma_int_t *dIPIV,
                               magmaDouble_ptr dB, size_t dB_offset, magma_int_t lddb,
                               magmaDouble_ptr dX, size_t dX_offset, magma_int_t lddx,
                               magmaDouble_ptr dworkd, magmaFloat_ptr dworks,
                               magma_int_t *iter, magma_int_t *info, magma_queue_t queue);

magma_int_t magma_dsgetrs_mic( magma_trans_t trans, magma_int_t n, magma_int_t nrhs,
                               magmaFloat_ptr dA, size_t dA_offset, magma_int_t ldda,
                               magma_int_t *ipiv,
                               magmaDouble_ptr dB, size_t dB_offset, magma_int_t lddb,
                               magmaDouble_ptr dX, size_t dX_offset, magma_int_t lddx,
                               magmaFloat_ptr dSX,
                               magma_int_t *info, magma_queue_t queue );

magma_int_t magma_dsposv_mic( magma_uplo_t uplo, magma_int_t n, magma_int_t nrhs,
                              magmaDouble_ptr dA, size_t dA_offset, magma_int_t ldda,
                              magmaDouble_ptr dB, size_t dB_offset, magma_int_t lddb,
                              magmaDouble_ptr dX, size_t dX_offset, magma_int_t lddx,
                              magmaDouble_ptr dworkd, magmaFloat_ptr dworks,
                              magma_int_t *iter, magma_int_t *info, magma_queue_t queue );

magma_int_t magma_dsgeqrsv_mic(magma_int_t M, magma_int_t N, magma_int_t NRHS,
                               magmaDouble_ptr dA, size_t dA_offset, magma_int_t ldda,
                               magmaDouble_ptr dB, size_t dB_offset, magma_int_t lddb,
                               magmaDouble_ptr dX, size_t dX_offset, magma_int_t lddx,
                               magma_int_t *iter,    magma_int_t *info, magma_queue_t queue);
  
magma_int_t magma_dsgesv(magma_int_t N, magma_int_t NRHS,
                         magmaDouble_ptr dA, size_t dA_offset, magma_int_t ldda,
                         magma_int_t *dIPIV,
                         magmaDouble_ptr dB, size_t dB_offset, magma_int_t lddb,
                         magmaDouble_ptr dX, size_t dX_offset, magma_int_t lddx,
                         magmaDouble_ptr dworkd, magmaFloat_ptr dworks,
                         magma_queue_t queue );

magma_int_t magma_dsgesv2(magma_trans_t trans, magma_int_t N, magma_int_t NRHS,
                          double *A, magma_int_t lda,
                          magmaFloat_ptr dA, size_t dA_offset, magma_int_t ldda,
                          magma_int_t *IPIV,  magma_int_t *dIPIV,
                          double *B, magma_int_t ldb,
                          double *X, magma_int_t ldx,
                          double *workd, float *works,
                          magma_int_t *iter, magma_int_t *info,
                          magma_queue_t queue );


/* Auxiliary routines */
magma_int_t magma_dsaxpycp( magma_int_t m,
                            magmaFloat_ptr r, size_t r_offset,
                            magmaDouble_ptr x, size_t x_offset,
                            magmaDouble_const_ptr b, size_t b_offset,
                            magmaDouble_ptr w, size_t w_offset,
                            magma_queue_t queue );

magma_int_t magma_dlag2s( magma_int_t m, magma_int_t n,
                          magmaDouble_ptr dA, size_t dA_offset, magma_int_t lda,
                          magmaFloat_ptr dAs, size_t dAs_offset, magma_int_t ldas,
                          magma_queue_t queue);

magma_int_t magma_dlat2s( magma_uplo_t uplo, magma_int_t n,
                          magmaDouble_ptr dA, size_t dA_offset, magma_int_t lda,
                          magmaFloat_ptr dAs, size_t dAs_offset, magma_int_t ldas,
                          magma_queue_t queue);

magma_int_t magma_slag2d( magma_int_t m, magma_int_t n,
                          magmaFloat_ptr dAs, size_t dAs_offset, magma_int_t ldas,
                          magmaDouble_ptr dA, size_t dA_offset, magma_int_t lda,
                          magma_queue_t queue);
#ifdef __cplusplus
}
#endif

#endif /* _MAGMA_D_H_ */
