/*
 *   -- micMAGMA (version 1.4.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      @date July 2015
 *
 *   @author Azzam Haidar
 *   @author Khairul Kabir
 *   @author Stan Tomov
 *   @author Hartwig Anzt
 *
 *   @generated from magma_z_bindings.h normal z -> d, Sun Jul 12 17:46:27 2015
 */


#ifndef MAGMA_D_BINDINGS
#define MAGMA_D_BINDINGS
#define PRECISION_d

typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magmaDouble_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaDouble_const_ptr x;
    magmaDouble_ptr y;
} magma_mic_dcsrgemv_param;

typedef struct {
    magma_int_t m;
    magmaDouble_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaDouble_ptr x;
    magmaDouble_const_ptr b;

    magmaDouble_ptr dwork;
} magma_mic_ddebug_param;

typedef struct {
    magma_int_t m;
    magmaDouble_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaDouble_ptr x;
    magmaDouble_const_ptr b;

    magma_d_solver_par *solver_par;
    magmaDouble_ptr dwork;
} magma_mic_dbicgstab_param;

typedef struct {
    magma_int_t m;
    magmaDouble_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaDouble_ptr x;
    magmaDouble_const_ptr b;

    magma_d_solver_par *solver_par;
    magmaDouble_ptr dwork;
} magma_mic_dcg_param;

typedef struct {
    magma_int_t m;
    magmaDouble_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaDouble_ptr x;
    magmaDouble_const_ptr b;

    magma_d_solver_par *solver_par;
    magmaDouble_ptr dwork;
} magma_mic_dgmres_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t request;
    magma_int_t sort;
    magma_int_t  m;
    magma_int_t  n;
    magma_int_t  k;
    double alpha;
    magmaDouble_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaDouble_const_ptr b;
    magmaIndex_const_ptr ib;
    magmaIndex_const_ptr jb;
    magmaDouble_ptr c;
    magmaIndex_ptr ic;
    magmaIndex_ptr jc;
    magma_int_t nzmax;
    magma_int_t info;
} magma_mic_dcsrgespmm_param;

typedef struct {
    magmaDouble_ptr res;
    magma_int_t n;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_ddot_param;

typedef struct {
    magmaDouble_ptr res;
    magma_int_t n;
    magmaDouble_const_ptr x;
    magma_int_t incx;
} magma_mic_dnrm2_param;

typedef struct {
    magma_int_t n;
    double a;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    magmaDouble_ptr y;
    magma_int_t incy;
} magma_mic_daxpy_param;

typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    magmaDouble_ptr y;
    magma_int_t incy;
} magma_mic_dcopy_param;

typedef struct {
    magma_trans_t transa;
    magma_trans_t transb;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
} magma_mic_dgemm_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_dsymm_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    double beta;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_dgemv_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    double beta;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_dsymv_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    double beta;
    magmaDouble_const_ptr y;
    magma_int_t incy;
    magma_int_t symvshift;
    magmaDouble_const_ptr partialY;
} magma_mic_dsymv_for_trd_param;

typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr d_A;
    magma_int_t lda;
    magmaDouble_const_ptr d_u;
    magmaDouble_const_ptr d_v;
} magma_mic_dprbt_param;


typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr d_u;
    magmaDouble_const_ptr d_b;
} magma_mic_dprbt_mtv_param;


typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr d_v;
    magmaDouble_const_ptr d_b;
} magma_mic_dprbt_mv_param;


typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    double beta;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_dsymv2_param;



typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
} magma_mic_dsyrk_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_dsyrk_mmic_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_dsyr2k_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    magma_int_t boff;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_dsyr2k_mmic_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
} magma_mic_dtrsm_param;

typedef struct {
    magma_mic_dtrsm_param trsm_param;
    magma_mic_dgemm_param gemm_param;
} magma_mic_dtrsmgemm_param;

typedef struct {
  magma_uplo_t uplo;
  magma_trans_t trans;
  magma_diag_t diag;
  magma_int_t n;
  double alpha;
  magmaDouble_const_ptr a;
  magma_int_t lda;
  magmaDouble_const_ptr dx;
  magma_int_t incx;
} magma_mic_dtrsv_param;

typedef struct {
  magma_uplo_t  uplo;
  magma_trans_t trans;
  magma_diag_t  diag;
  magma_int_t n;
  double alpha;
  magmaDouble_const_ptr a;
  magma_int_t lda;
  magmaDouble_const_ptr dx;
  magma_int_t incx;
} magma_mic_dtrmv_param;
 
typedef struct {
    magma_uplo_t uplo;
    magma_int_t n; 
    magma_int_t nb; 
    magma_int_t *kb;
    double *hA;
    magma_int_t lda;
    magmaDouble_ptr dA;
    magma_int_t ldda;
    magma_int_t *ipiv;
    magmaDouble_ptr dW;
    magma_int_t lddw;
} magma_mic_dlasyf_param;

typedef struct {
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t n;
    magma_int_t k;
    magmaDouble_const_ptr v;
    magma_int_t ldv;
    magmaDouble_const_ptr tau;
    magmaDouble_const_ptr t;
    magma_int_t ldt;
} magma_mic_dlarft_param;


typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaDouble_const_ptr v;
    magma_int_t ldv;
    magmaDouble_const_ptr t;
    magma_int_t ldt;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magmaDouble_const_ptr work;
    magma_int_t ldwork;
} magma_mic_dlarfb_param;

typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaDouble_const_ptr v;
    magma_int_t ldv;
    magmaDouble_const_ptr t;
    magma_int_t ldt;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magmaDouble_const_ptr work;
    magma_int_t ldwork;
    magmaDouble_const_ptr workvt;
    magma_int_t ldworkvt;
} magma_mic_dlarfb_gemm_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    double beta;
    magmaDouble_const_ptr dA;
    magma_int_t lda;
} magma_mic_dlaset_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
} magma_mic_dtrmm_param;


typedef struct {
    magmaDouble_const_ptr odata;
    magma_int_t ldo;
    magmaDouble_const_ptr idata;
    magma_int_t ldi;
    magma_int_t m;
    magma_int_t n;
} magma_mic_dtranspose_param;


/*
typedef struct {
    magmaDouble_const_ptr d_AT;
    magma_int_t lda;
    magma_int_t *d_ipiv;
    magma_int_t nb;
    magma_int_t ind;
} magma_mic_dlaswp_param;
*/


typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr d_A;
    magma_int_t lda;
    magma_int_t k1;
    magma_int_t k2;
    magma_int_t *d_ipiv;
    magma_int_t incx;
} magma_mic_dlaswp_param;


typedef struct {
    magma_int_t n;
    double *dA1T;
    magma_int_t lda1;
    double *dA2T;
    magma_int_t lda2;
} magma_mic_dswap_param;

typedef struct {
    magma_norm_t norm;
    magma_int_t m;
    magma_int_t n;
    magmaDouble_const_ptr dA; 
    magma_int_t ldda;
    magmaDouble_ptr dwork;
    double *ret;
} magma_mic_dlange_param;

typedef struct {
    magma_norm_t norm;
    magma_uplo_t uplo;
    magma_int_t n;
    magmaDouble_const_ptr dA;
    magma_int_t ldda;
    magmaDouble_ptr dwork;
    double *ret;
} magma_mic_dlansy_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaDouble_const_ptr dA;
    magma_int_t ldda;
    magmaDouble_ptr dB;
    magma_int_t lddb;
} magma_mic_dlacpy_param;


typedef struct {
    magma_int_t n;
    double alpha;
    magmaDouble_ptr dx;
    magma_int_t incx;
} magma_mic_dscal_param;


typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaDouble_ptr dA;
    magma_int_t ldda;
    magmaDouble_ptr dB;
    magma_int_t lddb;
} magma_mic_dlascl_diag_param;


typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr dx; 
    magma_int_t incx;
    magma_int_t *ret;
} magma_mic_idamax_param;

typedef struct {
    magma_int_t m;
    double *r; 
    double *x; 
    double *b; 
} magma_mic_daxpycp2_param;



// SPARSE

typedef struct {
    magma_int_t m;
    magma_int_t n;
    magmaDouble_ptr d;
    magmaDouble_ptr b;
    magmaDouble_ptr c;
} magma_mic_djacobidiagscale_param;


#endif  // MAGMA_D_BINDINGS
