/*
 *   -- micMAGMA (version 1.4.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      @date July 2015
 *
 *   @generated from magma_zc_bindings.h mixed zc -> ds, Sun Jul 12 17:46:27 2015
 */

#ifndef MAGMA_DS_BINDINGS
#define MAGMA_DS_BINDINGS

typedef struct {
  magma_int_t m;
  magmaFloat_ptr r;
  magmaDouble_ptr x;
  magmaDouble_const_ptr b;
  magmaDouble_ptr w;
} magma_mic_dsaxpycp_param;

typedef struct {
  magma_int_t m;
  magma_int_t n;
  magmaDouble_const_ptr dA;
  magma_int_t lda;
  magmaFloat_const_ptr dAs;
  magma_int_t ldas;
} magma_mic_dlag2s_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    magmaDouble_const_ptr dA;
    magma_int_t lda;
    magmaFloat_const_ptr dAs;
    magma_int_t ldas;
} magma_mic_dlat2s_param;

typedef struct {
  magma_int_t m;
  magma_int_t n;
  magmaFloat_const_ptr dAs;
  magma_int_t ldas;
  magmaDouble_const_ptr dA;
  magma_int_t lda;
} magma_mic_slag2d_param;


typedef struct {
  magma_int_t n;
  magma_int_t nrhs;
  magmaDouble_const_ptr d_A;
  magma_int_t lda;
  magma_int_t *d_ipiv;
  magmaDouble_const_ptr d_B;
  magma_int_t ldb;
  magmaDouble_const_ptr d_X;
  magma_int_t ldx;
  magmaDouble_const_ptr d_work;
  magmaFloat_const_ptr d_swork;
} magma_mic_dsgesv_param;

#endif  // MAGMA_DS_BINDINGS
