/*
 *   -- micMAGMA (version 1.4.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      @date July 2015
 *
 *   @author Azzam Haidar
 *   @author Khairul Kabir
 *   @author Stan Tomov
 *   @author Hartwig Anzt
 *
 *   @generated from magma_z_bindings.h normal z -> s, Sun Jul 12 17:46:27 2015
 */


#ifndef MAGMA_S_BINDINGS
#define MAGMA_S_BINDINGS
#define PRECISION_s

typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magmaFloat_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloat_const_ptr x;
    magmaFloat_ptr y;
} magma_mic_scsrgemv_param;

typedef struct {
    magma_int_t m;
    magmaFloat_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloat_ptr x;
    magmaFloat_const_ptr b;

    magmaFloat_ptr dwork;
} magma_mic_sdebug_param;

typedef struct {
    magma_int_t m;
    magmaFloat_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloat_ptr x;
    magmaFloat_const_ptr b;

    magma_s_solver_par *solver_par;
    magmaFloat_ptr dwork;
} magma_mic_sbicgstab_param;

typedef struct {
    magma_int_t m;
    magmaFloat_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloat_ptr x;
    magmaFloat_const_ptr b;

    magma_s_solver_par *solver_par;
    magmaFloat_ptr dwork;
} magma_mic_scg_param;

typedef struct {
    magma_int_t m;
    magmaFloat_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloat_ptr x;
    magmaFloat_const_ptr b;

    magma_s_solver_par *solver_par;
    magmaFloat_ptr dwork;
} magma_mic_sgmres_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t request;
    magma_int_t sort;
    magma_int_t  m;
    magma_int_t  n;
    magma_int_t  k;
    float alpha;
    magmaFloat_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloat_const_ptr b;
    magmaIndex_const_ptr ib;
    magmaIndex_const_ptr jb;
    magmaFloat_ptr c;
    magmaIndex_ptr ic;
    magmaIndex_ptr jc;
    magma_int_t nzmax;
    magma_int_t info;
} magma_mic_scsrgespmm_param;

typedef struct {
    magmaFloat_ptr res;
    magma_int_t n;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_sdot_param;

typedef struct {
    magmaFloat_ptr res;
    magma_int_t n;
    magmaFloat_const_ptr x;
    magma_int_t incx;
} magma_mic_snrm2_param;

typedef struct {
    magma_int_t n;
    float a;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    magmaFloat_ptr y;
    magma_int_t incy;
} magma_mic_saxpy_param;

typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    magmaFloat_ptr y;
    magma_int_t incy;
} magma_mic_scopy_param;

typedef struct {
    magma_trans_t transa;
    magma_trans_t transb;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
} magma_mic_sgemm_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_ssymm_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    float beta;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_sgemv_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    float beta;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_ssymv_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    float beta;
    magmaFloat_const_ptr y;
    magma_int_t incy;
    magma_int_t symvshift;
    magmaFloat_const_ptr partialY;
} magma_mic_ssymv_for_trd_param;

typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr d_A;
    magma_int_t lda;
    magmaFloat_const_ptr d_u;
    magmaFloat_const_ptr d_v;
} magma_mic_sprbt_param;


typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr d_u;
    magmaFloat_const_ptr d_b;
} magma_mic_sprbt_mtv_param;


typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr d_v;
    magmaFloat_const_ptr d_b;
} magma_mic_sprbt_mv_param;


typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    float beta;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_ssymv2_param;



typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
} magma_mic_ssyrk_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_ssyrk_mmic_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_ssyr2k_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    magma_int_t boff;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_ssyr2k_mmic_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
} magma_mic_strsm_param;

typedef struct {
    magma_mic_strsm_param trsm_param;
    magma_mic_sgemm_param gemm_param;
} magma_mic_strsmgemm_param;

typedef struct {
  magma_uplo_t uplo;
  magma_trans_t trans;
  magma_diag_t diag;
  magma_int_t n;
  float alpha;
  magmaFloat_const_ptr a;
  magma_int_t lda;
  magmaFloat_const_ptr dx;
  magma_int_t incx;
} magma_mic_strsv_param;

typedef struct {
  magma_uplo_t  uplo;
  magma_trans_t trans;
  magma_diag_t  diag;
  magma_int_t n;
  float alpha;
  magmaFloat_const_ptr a;
  magma_int_t lda;
  magmaFloat_const_ptr dx;
  magma_int_t incx;
} magma_mic_strmv_param;
 
typedef struct {
    magma_uplo_t uplo;
    magma_int_t n; 
    magma_int_t nb; 
    magma_int_t *kb;
    float *hA;
    magma_int_t lda;
    magmaFloat_ptr dA;
    magma_int_t ldda;
    magma_int_t *ipiv;
    magmaFloat_ptr dW;
    magma_int_t lddw;
} magma_mic_slasyf_param;

typedef struct {
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t n;
    magma_int_t k;
    magmaFloat_const_ptr v;
    magma_int_t ldv;
    magmaFloat_const_ptr tau;
    magmaFloat_const_ptr t;
    magma_int_t ldt;
} magma_mic_slarft_param;


typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaFloat_const_ptr v;
    magma_int_t ldv;
    magmaFloat_const_ptr t;
    magma_int_t ldt;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magmaFloat_const_ptr work;
    magma_int_t ldwork;
} magma_mic_slarfb_param;

typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaFloat_const_ptr v;
    magma_int_t ldv;
    magmaFloat_const_ptr t;
    magma_int_t ldt;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magmaFloat_const_ptr work;
    magma_int_t ldwork;
    magmaFloat_const_ptr workvt;
    magma_int_t ldworkvt;
} magma_mic_slarfb_gemm_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    float beta;
    magmaFloat_const_ptr dA;
    magma_int_t lda;
} magma_mic_slaset_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
} magma_mic_strmm_param;


typedef struct {
    magmaFloat_const_ptr odata;
    magma_int_t ldo;
    magmaFloat_const_ptr idata;
    magma_int_t ldi;
    magma_int_t m;
    magma_int_t n;
} magma_mic_stranspose_param;


/*
typedef struct {
    magmaFloat_const_ptr d_AT;
    magma_int_t lda;
    magma_int_t *d_ipiv;
    magma_int_t nb;
    magma_int_t ind;
} magma_mic_slaswp_param;
*/


typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr d_A;
    magma_int_t lda;
    magma_int_t k1;
    magma_int_t k2;
    magma_int_t *d_ipiv;
    magma_int_t incx;
} magma_mic_slaswp_param;


typedef struct {
    magma_int_t n;
    float *dA1T;
    magma_int_t lda1;
    float *dA2T;
    magma_int_t lda2;
} magma_mic_sswap_param;

typedef struct {
    magma_norm_t norm;
    magma_int_t m;
    magma_int_t n;
    magmaFloat_const_ptr dA; 
    magma_int_t ldda;
    magmaFloat_ptr dwork;
    float *ret;
} magma_mic_slange_param;

typedef struct {
    magma_norm_t norm;
    magma_uplo_t uplo;
    magma_int_t n;
    magmaFloat_const_ptr dA;
    magma_int_t ldda;
    magmaFloat_ptr dwork;
    float *ret;
} magma_mic_slansy_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaFloat_const_ptr dA;
    magma_int_t ldda;
    magmaFloat_ptr dB;
    magma_int_t lddb;
} magma_mic_slacpy_param;


typedef struct {
    magma_int_t n;
    float alpha;
    magmaFloat_ptr dx;
    magma_int_t incx;
} magma_mic_sscal_param;


typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaFloat_ptr dA;
    magma_int_t ldda;
    magmaFloat_ptr dB;
    magma_int_t lddb;
} magma_mic_slascl_diag_param;


typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr dx; 
    magma_int_t incx;
    magma_int_t *ret;
} magma_mic_isamax_param;

typedef struct {
    magma_int_t m;
    float *r; 
    float *x; 
    float *b; 
} magma_mic_saxpycp2_param;



// SPARSE

typedef struct {
    magma_int_t m;
    magma_int_t n;
    magmaFloat_ptr d;
    magmaFloat_ptr b;
    magmaFloat_ptr c;
} magma_mic_sjacobidiagscale_param;


#endif  // MAGMA_S_BINDINGS
