/*
 *   -- micMAGMA (version 1.4.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      @date July 2015
 *
 *   @precisions mixed zc -> ds
 */

#ifndef MAGMA_ZC_BINDINGS
#define MAGMA_ZC_BINDINGS

typedef struct {
  magma_int_t m;
  magmaFloatComplex_ptr r;
  magmaDoubleComplex_ptr x;
  magmaDoubleComplex_const_ptr b;
  magmaDoubleComplex_ptr w;
} magma_mic_zcaxpycp_param;

typedef struct {
  magma_int_t m;
  magma_int_t n;
  magmaDoubleComplex_const_ptr dA;
  magma_int_t lda;
  magmaFloatComplex_const_ptr dAs;
  magma_int_t ldas;
} magma_mic_zlag2c_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    magmaDoubleComplex_const_ptr dA;
    magma_int_t lda;
    magmaFloatComplex_const_ptr dAs;
    magma_int_t ldas;
} magma_mic_zlat2c_param;

typedef struct {
  magma_int_t m;
  magma_int_t n;
  magmaFloatComplex_const_ptr dAs;
  magma_int_t ldas;
  magmaDoubleComplex_const_ptr dA;
  magma_int_t lda;
} magma_mic_clag2z_param;


typedef struct {
  magma_int_t n;
  magma_int_t nrhs;
  magmaDoubleComplex_const_ptr d_A;
  magma_int_t lda;
  magma_int_t *d_ipiv;
  magmaDoubleComplex_const_ptr d_B;
  magma_int_t ldb;
  magmaDoubleComplex_const_ptr d_X;
  magma_int_t ldx;
  magmaDoubleComplex_const_ptr d_work;
  magmaFloatComplex_const_ptr d_swork;
} magma_mic_zcgesv_param;

#endif  // MAGMA_ZC_BINDINGS
