/*
 *   -- micMAGMA (version 1.4.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 * @author Azzam Haidar
 * @author Khairul Kabir
 *
 * @generated from magma_z_server.cpp normal z -> d, Sun Jul 12 17:46:28 2015
 */

#include <mkl.h>

#include <mkl_trans.h>
#include <scif.h>
#include <fcntl.h>
#include <offload.h>

//#ifdef __MIC__
//#define _M512_TYPED
//#include <lmmintrin.h>
//#endif
#include <immintrin.h>

#include "magmasparse.h"
#include "magma.h"
//#include "magma_d_bindings.h"
#include "magma_d_server.h"

#define min(a, b) ((a) < (b) ? (a) : (b))

#define PRECISION_d
#define REAL

void magmablas_delementary_multiplication(
    magma_int_t n,
    double *dA, magma_int_t ldda, 
    double *du, double *dv)
{    

    magma_int_t idx, idy;


	double *dAt;
#pragma omp parallel for  
	for(idy = 0 ; idy < n/2; idy++)
	{
		for(idx = 0; idx < n/2; idx++)
		{


			double b1, b2, b3, b4;



			b1 = dA[idx + idy * ldda] + dA[idx + ldda*(idy+n/2)];
			b2 = dA[idx + n/2 + idy* ldda] + dA[idx+n/2 + ldda*(idy+n/2)];
			b3 = dA[idx + idy * ldda] - dA[idx + ldda*(idy+n/2)];
			b4 = dA[idx + n/2 + idy* ldda] - dA[idx+n/2 + ldda*(idy+n/2)];


			
			
			dA[idx + idy * ldda] = du[idx] * dv[idy] * (b1 + b2);
			dA[idx + ldda*(idy+n/2)] = du[idx] * dv[idy+n/2] * (b3 + b4);
			dA[idx + n/2 + idy* ldda] = du[idx+ n/2] * dv[idy] * (b1 - b2);
			dA[idx+n/2 + ldda*(idy+n/2)] = du[idx+n/2] * dv[idy+n/2] *(b3 - b4);
		}
	}
}
#if 0
__m512d mulDoubleComp(__m512d a, __m512d b) 
{
    __m512d b_flip = _mm512_shuffle_pd(b,b,0x55);   // Swap b.re and b.im

    __m512d a_im   = _mm512_shuffle_pd(a,a,0xFF);   // Imag. part of a in both

    __m512d a_re   = _mm512_shuffle_pd(a,a,0x00);   // Real part of a in both

    __m512d aib    = _mm512_mul_pd(a_im, b_flip);   // (a.im*b.im, a.im*b.re)


    return  _mm512_fmaddsub_pd(a_re, b, aib);      

}

void 
magmablas_delementary_multiplication0(
        magma_int_t n,
        double *dA, magma_int_t ldda,
        double *du, double *dv)
{    
    magma_int_t idx, idy;

#pragma omp parallel for
    for(idy = 0 ; idy < n/2; idy++)
    {
        __m512d dv1, dv2;
        dv1 = _mm512_set_pd(MAGMA_D_IMAG(dv[idy]),MAGMA_D_REAL(dv[idy]),
                MAGMA_D_IMAG(dv[idy]),MAGMA_D_REAL(dv[idy]),
                MAGMA_D_IMAG(dv[idy]),MAGMA_D_REAL(dv[idy]),
                MAGMA_D_IMAG(dv[idy]),MAGMA_D_REAL(dv[idy]));
        dv2 = _mm512_set_pd(MAGMA_D_IMAG(dv[idy+n/2]),MAGMA_D_REAL(dv[idy+n/2]),
                MAGMA_D_IMAG(dv[idy+n/2]),MAGMA_D_REAL(dv[idy+n/2]),
                MAGMA_D_IMAG(dv[idy+n/2]),MAGMA_D_REAL(dv[idy+n/2]),
                MAGMA_D_IMAG(dv[idy+n/2]),MAGMA_D_REAL(dv[idy+n/2]));

        for(idx = 0; idx < n/2; idx+=4)
        {
            __m512d b1, b2, b3, b4, a0, a1, a2, a3 ;
		//	__m512d b5, b6, b7, b8;
	

			a0 = _mm512_load_pd(&dA[idx + idy * ldda]);
			a1 = _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]);
			a2 = _mm512_load_pd(&dA[idx + n/2 + idy* ldda]);
			a3 = _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]);


			b1 =_mm512_add_pd( a0 ,a1);
			b2 = _mm512_add_pd( a2, a3);
			b3 = _mm512_sub_pd(a0 , a1);
			b4 = _mm512_sub_pd(a2 ,  a3);

		//	b1 =_mm512_add_pd( _mm512_load_pd(&dA[idx + idy * ldda]) , _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b2 = _mm512_add_pd(  _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));
		//	b3 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + idy * ldda]) ,  _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b4 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));

			__m512d du1, du2;

			du1 = _mm512_load_pd(&du[idx]);
			du2 = _mm512_load_pd(&du[idx+n/2]);

			_mm512_store_pd(&dA[idx + idy * ldda] , mulDoubleComp(du1 , mulDoubleComp(dv1 , _mm512_add_pd(b1,  b2))));
			_mm512_store_pd(&dA[idx + ldda*(idy+n/2)] , mulDoubleComp( du1 , mulDoubleComp( dv2 , _mm512_add_pd(b3 , b4))));
			_mm512_store_pd(&dA[idx + n/2 + idy* ldda] , mulDoubleComp(du2 , mulDoubleComp(dv1 , _mm512_sub_pd(b1 , b2))));
			_mm512_store_pd(&dA[idx+n/2 + ldda*(idy+n/2)] , mulDoubleComp(du2 , mulDoubleComp( dv2 , _mm512_sub_pd(b3 , b4))));
		}
	}
}
#endif


#ifndef COMPLEX
#ifdef PRECISION_d
void 
magmablas_delementary_multiplication0(
    magma_int_t n,
    double *dA, magma_int_t ldda,
    double *du, double *dv)
{    
	magma_int_t idx, idy;

#pragma omp parallel for
	for(idy = 0 ; idy < n/2; idy++)
	{
		__m512d dv1, dv2;
		dv1 = _mm512_set1_pd(dv[idy]);
		dv2 = _mm512_set1_pd(dv[idy+n/2]);

		for(idx = 0; idx < n/2; idx+=8)
		{
			__m512d b1, b2, b3, b4, a0, a1, a2, a3 ;
		//	__m512d b5, b6, b7, b8;
	

			a0 = _mm512_load_pd(&dA[idx + idy * ldda]);
			a1 = _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]);
			a2 = _mm512_load_pd(&dA[idx + n/2 + idy* ldda]);
			a3 = _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]);


			b1 =_mm512_add_pd( a0 ,a1);
			b2 = _mm512_add_pd( a2, a3);
			b3 = _mm512_sub_pd(a0 , a1);
			b4 = _mm512_sub_pd(a2 ,  a3);

		//	b1 =_mm512_add_pd( _mm512_load_pd(&dA[idx + idy * ldda]) , _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b2 = _mm512_add_pd(  _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));
		//	b3 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + idy * ldda]) ,  _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b4 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));

			__m512d du1, du2;

			du1 = _mm512_load_pd(&du[idx]);
			du2 = _mm512_load_pd(&du[idx+n/2]);

			_mm512_store_pd(&dA[idx + idy * ldda] , _mm512_mul_pd(du1 , _mm512_mul_pd(dv1 , _mm512_add_pd(b1,  b2))));
			_mm512_store_pd(&dA[idx + ldda*(idy+n/2)] , _mm512_mul_pd( du1 , _mm512_mul_pd( dv2 , _mm512_add_pd(b3 , b4))));
			_mm512_store_pd(&dA[idx + n/2 + idy* ldda] , _mm512_mul_pd(du2 , _mm512_mul_pd(dv1 , _mm512_sub_pd(b1 , b2))));
			_mm512_store_pd(&dA[idx+n/2 + ldda*(idy+n/2)] , _mm512_mul_pd(du2 , _mm512_mul_pd( dv2 , _mm512_sub_pd(b3 , b4))));
		}
	}
}
#else

void magmablas_delementary_multiplication0(
    magma_int_t n,
    double *dA, magma_int_t ldda,
    double *du, double *dv)
{    
	magma_int_t idx, idy;

#pragma omp parallel for
	for(idy = 0 ; idy < n/2; idy++)
	{
		__m512 dv1, dv2;
		dv1 = _mm512_set1_ps(dv[idy]);
		dv2 = _mm512_set1_ps(dv[idy+n/2]);

		for(idx = 0; idx < n/2; idx+=16)
		{
			__m512 b1, b2, b3, b4, a0, a1, a2, a3 ;
		//	__m512 b5, b6, b7, b8;
	

			a0 = _mm512_load_ps(&dA[idx + idy * ldda]);
			a1 = _mm512_load_ps(&dA[idx + ldda*(idy+n/2)]);
			a2 = _mm512_load_ps(&dA[idx + n/2 + idy* ldda]);
			a3 = _mm512_load_ps(&dA[idx+n/2 + ldda*(idy+n/2)]);


			b1 =_mm512_add_ps( a0 ,a1);
			b2 = _mm512_add_ps( a2, a3);
			b3 = _mm512_sub_ps(a0 , a1);
			b4 = _mm512_sub_ps(a2 ,  a3);

		//	b1 =_mm512_add_ps( _mm512_load_ps(&dA[idx + idy * ldda]) , _mm512_load_ps(&dA[idx + ldda*(idy+n/2)]));
		//	b2 = _mm512_add_ps(  _mm512_load_ps(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_ps(&dA[idx+n/2 + ldda*(idy+n/2)]));
		//	b3 = _mm512_sub_ps( _mm512_load_ps(&dA[idx + idy * ldda]) ,  _mm512_load_ps(&dA[idx + ldda*(idy+n/2)]));
		//	b4 = _mm512_sub_ps( _mm512_load_ps(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_ps(&dA[idx+n/2 + ldda*(idy+n/2)]));

			__m512 du1, du2;

			du1 = _mm512_load_ps(&du[idx]);
			du2 = _mm512_load_ps(&du[idx+n/2]);

			_mm512_store_ps(&dA[idx + idy * ldda] , _mm512_mul_ps(du1 , _mm512_mul_ps(dv1 , _mm512_add_ps(b1,  b2))));
			_mm512_store_ps(&dA[idx + ldda*(idy+n/2)] , _mm512_mul_ps( du1 , _mm512_mul_ps( dv2 , _mm512_add_ps(b3 , b4))));
			_mm512_store_ps(&dA[idx + n/2 + idy* ldda] , _mm512_mul_ps(du2 , _mm512_mul_ps(dv1 , _mm512_sub_ps(b1 , b2))));
			_mm512_store_ps(&dA[idx+n/2 + ldda*(idy+n/2)] , _mm512_mul_ps(du2 , _mm512_mul_ps( dv2 , _mm512_sub_ps(b3 , b4))));
		}
	}
}

#endif
#endif
void magmablas_dapply_vector(double *du, double *db, magma_int_t n)
{
	magma_int_t idx;

//	#pragma omp parallel for
	for(idx = 0; idx < n/2; idx++)
	{


		double a1,a2;

		a1 = du[idx]*db[idx];
		a2 = du[idx+n/2]*db[idx+n/2];

		db[idx] = a1 + a2;
		db[idx+n/2] = a1 -a2;
	}
}

void magmablas_dapply_transpose_vector(double *du, double *db, magma_int_t n)
{
	int idx;


//	#pragma omp parallel for
	for(idx = 0; idx < n/2; idx++)
	{


		double a1,a2;

		a1 = db[idx] + db[idx+n/2];
		a2 = db[idx] - db[idx+n/2];

		db[idx] = du[idx]*a1;
		db[idx+n/2] = du[idx+n/2]*a2;
	}
}



void dprbt(
    magma_int_t n, 
    double *d_A, magma_int_t ldda, 
    double *d_u, double *d_v)
{
	/*
	 *
	 * */
	d_u += ldda;
	d_v += ldda;
	
#ifdef COMPLEX
    magmablas_delementary_multiplication(n/2, d_A, ldda, d_u, d_v);
	magmablas_delementary_multiplication(n/2, d_A+ldda*n/2, ldda, d_u, d_v+n/2);
	magmablas_delementary_multiplication(n/2, d_A+n/2, ldda, d_u+n/2, d_v);
	magmablas_delementary_multiplication(n/2, d_A+ldda*n/2+n/2, ldda, d_u+n/2, d_v+n/2);
	magmablas_delementary_multiplication(n, d_A, ldda, d_u-ldda, d_v-ldda);
#else
    magmablas_delementary_multiplication0(n/2, d_A, ldda, d_u, d_v);
	magmablas_delementary_multiplication0(n/2, d_A+ldda*n/2, ldda, d_u, d_v+n/2);
	magmablas_delementary_multiplication0(n/2, d_A+n/2, ldda, d_u+n/2, d_v);
	magmablas_delementary_multiplication0(n/2, d_A+ldda*n/2+n/2, ldda, d_u+n/2, d_v+n/2);
	magmablas_delementary_multiplication0(n, d_A, ldda, d_u-ldda, d_v-ldda);
#endif
}



void dprbt_mtv(
    magma_int_t n, 
    double *d_u, double *d_b)
{
	/*
	 *
	 * */
	magmablas_dapply_transpose_vector(d_u+n,    d_b,n/2);
	magmablas_dapply_transpose_vector(d_u+n+n/2,d_b+n/2,n/2);

	magmablas_dapply_transpose_vector(d_u,d_b,n);
}



void dprbt_mv(
    magma_int_t n, 
    double *d_v, double *d_b)
{
	/*
	 *
	 * */

	magmablas_dapply_vector(d_v,d_b,n);



	magmablas_dapply_vector(d_v+n,    d_b,n/2);
	magmablas_dapply_vector(d_v+n+n/2,d_b+n/2,n/2);


}


void call_dprbt(magma_mic_dprbt_param param)
{
	magma_int_t n, ldda;
	double* dA, *du, *dv;
	n = param.n;
	dA = (double*) param.d_A;
	ldda = param.lda;
	du = (double*)param.d_u;
	dv = (double*)param.d_v;

	dprbt(n, dA, ldda, du, dv);
}



void call_dprbt_mtv(magma_mic_dprbt_mtv_param param)
{
	magma_int_t n;
	double *du, *db;
	n = param.n;
	du = (double*)param.d_u;
	db = (double*)param.d_b;

	dprbt_mtv(n, du, db);
}

void call_dprbt_mv(magma_mic_dprbt_mv_param param)
{
	magma_int_t n;
	double *dv, *db;
	n = param.n;
	dv = (double*)param.d_v;
	db = (double*)param.d_b;

	dprbt_mv(n, dv, db);
}

//=========================================================================================
#ifdef PRECISION_z
typedef struct {
    magma_int_t n;
    magma_int_t elemSize;
    void const* dx_src;
    magma_int_t incx;
    void*      dy_dst;
    magma_int_t incy;
} magma_mic_vcopy_param;

typedef struct {
    magma_int_t m;
    magma_int_t n;
    magma_int_t elemSize;
    void const* dA_src;
    magma_int_t lda;
    void*       dB_dst;
    magma_int_t ldb;
} magma_mic_mcopy_param;

void call_vcopy(magma_mic_vcopy_param param)
{
    magma_int_t n        = param.n;
    magma_int_t elemSize = param.elemSize;
    void const* dx_src   = param.dx_src;
    magma_int_t incx     = param.incx; 
    void*       dy_dst   = param.dy_dst; 
    magma_int_t incy     = param.incy;

    /* sequential version */
    magma_int_t ix=0, iy=0;
    for (magma_int_t i=0; i < n; i++) {
        memcpy(dy_dst+iy, dx_src+ix, elemSize);
        ix += incx*elemSize;
        iy += incy*elemSize;
    }
}

void call_mcopy(magma_mic_mcopy_param param)
{
    magma_int_t m        = param.m;
    magma_int_t n        = param.n;
    magma_int_t elemSize = param.elemSize;
    void const* dA_src   = param.dA_src;
    magma_int_t lda      = param.lda;
    void*       dB_dst   = param.dB_dst;
    magma_int_t ldb      = param.ldb;

    /* sequential version */
    magma_int_t ix=0, iy=0;
    for (magma_int_t i=0; i < n; i++) {
        memcpy(dB_dst + i*ldb*elemSize, dA_src + i*lda*elemSize, m*elemSize);
    }
}
#endif

//=========================================================================================
void call_dcopy(magma_mic_dcopy_param param)
{
    magma_int_t n, incx, incy;
    double  *x, *y;
    
    n      = param.n;
    x      = (double *)param.x;
    incx   = param.incx;
    y      = (double *)param.y;
    incy   = param.incy;
    
    /* sequential version I think the compiler is optimizing it */
    magma_int_t ix=0, iy=0, ii, chunk=1, nthreads, tid;
    /*if (incx < 0) ix = (-n+1)*incx;
    if (incy < 0) iy = (-n+1)*incy;
    #pragma ivdep
    #pragma simd
    for (magma_int_t i=0; i < n; i++) {
           y[iy] = x[ix];
           ix += incx;
           iy += incy;
    }*/

    /* parallel version, where I use openmp to parallelize the copy */
 /* not tested if incx or incy < 0i*/
    #pragma omp parallel
    {
        magma_int_t ix=0, iy=0, ii, nthreads, tid;
        tid      = omp_get_thread_num();
        nthreads = omp_get_num_threads();
        if (incx < 0) ix = (-n+1)*incx;
        if (incy < 0) iy = (-n+1)*incy;
        ix = ix + tid*incx;
        iy = iy + tid*incy;
        for (ii=0; ii < n; ii += nthreads) {
            if ((ii+tid) < n) {
                y[iy] = x[ix];
                ix = ix + incx * nthreads;
                iy = iy + incy * nthreads;
            }
        }
    }

    // mkl_dcopy is not optimized yet and thus giving bad perf.
    // it is better to use the handcode as the compiler is intelligent and
    // optimizes the code better. Azzam
    //dcopy( &n, (double *)x, &incx, (double *)y, &incy);
}


//=========================================================================================
//magmablas our dsymm only left implemented here Azzam
//=========================================================================================
void magmablas_dsymm_mic(
    magma_side_t side, magma_uplo_t uplo, magma_int_t n, magma_int_t k, magma_int_t nb,
    double alpha, double *a, magma_int_t lda,
                              double *b, magma_int_t ldb,
    double beta,  double *c, magma_int_t ldc, magma_int_t agboff)
{
    #define dA(i, j) (a + (i) + (j)*lda)
    #define dB(i, j) (b + (i) + (j)*ldb)
    #define dC(i, j) (c + (i) + (j)*ldc)

    const double c_one = MAGMA_D_ONE;
    double newbeta = beta;
    magma_int_t m, ib, ioff, blockoffset;
    // loop over all blocks and does A*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    blockoffset = agboff % nb;
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        /*
        // Symmetrize the upper part of this block
        for (magma_int_t col=0; col < ib; col++) {
            for (magma_int_t row=0; row < col; row++) {
                *dA(i+row, i+col) =  MAGMA_D_CNJG( *(dA(i+col, i+row)) );
            }
        }
        */
        // C[i:n,0] += alpha * A[i:n,i] * B[i,0]
        /*
        m = n - i -ib;
        dsymm( lapack_const(side), lapack_const(uplo),
              &ib, &k, (const double *)&alpha, (double *)(dA(i, i)), &lda,
              (double *)(dB(i,0)), &ldb, (const double *)&newbeta,
              (double *)(dC(i,0)), &ldc);

        dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaNoTrans), &m, &k, &ib,
               (const double *)&alpha,   (double *)(dA(ioff+ib, ioff)), &lda,
                                                (double *)(dB(i,0)),           &ldb,
               (const double *)&newbeta, (double *)(dC(i+ib,0)),        &ldc );
        */
        m = n - i;
        dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaNoTrans), &m, &k, &ib,
               (const double *)&alpha,   (double *)(dA(i,i)), &lda,
                                                (double *)(dB(i,0)), &ldb,
               (const double *)&newbeta, (double *)(dC(i,0)), &ldc );
        

        dgemm( lapack_const(MagmaConjTrans), lapack_const(MagmaNoTrans), &i, &k, &ib,
               (const double *)&alpha,   (double *)(dA(i,0)), &lda,
                                                (double *)(dB(i,0)), &ldb,
               (const double *)&newbeta, (double *)(dC(0,0)), &ldc );

        newbeta = c_one;
        blockoffset = 0;
    }
    
    #undef dA
    #undef dB
    #undef dC
}

//=========================================================================================
void call_dsymm(magma_mic_dsymm_param param)
{
    magma_side_t side;
    magma_uplo_t uplo;
    magma_int_t m, n, lda, ldb, ldc, agboff;
    double alpha, beta, *a, *b, *c;

    side   = param.side;
    uplo   = param.uplo;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    b      = (double *)param.b;
    ldb    = param.ldb;
    beta   = param.beta;
    c      = (double *)param.c;
    ldc    = param.ldc;
    agboff = param.agboff;
    
    if ((side == MagmaLeft) && (uplo == MagmaLower)) {
        //printf("calling AZZAM SYMM m %d   n %d   agboff %d\n", m, n, agboff);
        //Azzam: calling only the Left Lower. need to be developed for all cases
        magma_int_t nb = 960;
        magmablas_dsymm_mic(side, uplo,
                         m, n, nb, alpha, a, lda, b, ldb,
                         beta, c, ldc, agboff);
    } else {
        //printf("calling MKL SYMM m %d   n %d \n", m, n);
        dsymm( lapack_const(side), lapack_const(uplo),
               &m, &n, (const double *)&alpha, (double *)a, &lda,
               (double *)b, &ldb, (const double *)&beta,
               (double *)c, &ldc);
    }
}

//=========================================================================================
void call_dgemm(magma_mic_dgemm_param param)
{
    magma_trans_t transa, transb;
    magma_int_t m, n, k, lda, ldb, ldc;
    double alpha, beta, *a, *b, *c;
    
    transa = param.transa;
    transb = param.transb;
    m      = param.m;
    n      = param.n;
    k      = param.k;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    b      = (double *)param.b;
    ldb    = param.ldb;
    beta   = param.beta;
    c      = (double *)param.c;
    ldc    = param.ldc;

    //printf("DGEMM: %c %c %d %d %d %f 0x%lx %d 0x%lx %d %f 0x%lx %d\n", transa, transb, m, n, k, alpha, (off_t)a, lda, (off_t)b, ldb, beta, (off_t)c, ldc);

    dgemm( lapack_const(transa), lapack_const(transb),
           &m, &n, &k, (const double *)&alpha, (double *)a, &lda,
           (double *)b, &ldb, (const double *)&beta,
           (double *)c, &ldc);
}

//=========================================================================================

#ifdef PRECISION_d

//working version - using intrensic
void dgemv_kernel_N_v2(int M, int N, double alpha, double *A, int lda, double *X, int incx, double beta, double *Y, int incy, int localtid, int thpgr) 
{
    #define A(i,j) A + (i) + (j)*lda
    #define Y(i)   Y + (i)
    #define X(i)   X + (i)

    int row, col;
    //version 2
    double *myA;
    double prod=0.;
    int PF1 = 8;
    int CLBLK = 4;
    
    __m512d va0, va1, va2, va3, vy, vtmp0, vtmp1, vtmp2, vtmp3, valpha, vx0, vx1, vx2, vx3; 
    double x0, x1;
    valpha = _mm512_extload_pd(&alpha, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);

    int misalignrow = ((64 - (((unsigned long)&A[0]) & 63)) / 8) % 8;
    misalignrow = (M < misalignrow) ? M : misalignrow;
    int m8 = misalignrow + (((M - misalignrow) % 8 == 0) ? (M - misalignrow) : (M - misalignrow - 1) / 8 * 8);
    
    for(col = 0; col < N; col += CLBLK) {
        int cblk = (N - col) < CLBLK ? (N - col) : CLBLK;
        if(cblk == CLBLK) {
            double prod0 = alpha * X[col + 0];
            double prod1 = alpha * X[col + 1];
            double prod2 = alpha * X[col + 2];
            double prod3 = alpha * X[col + 3];
        
            vx0 = _mm512_extload_pd(X + col + 0, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vx1 = _mm512_extload_pd(X + col + 1, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vx2 = _mm512_extload_pd(X + col + 2, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vx3 = _mm512_extload_pd(X + col + 3, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vtmp0 = _mm512_mul_pd(valpha, vx0);
            vtmp1 = _mm512_mul_pd(valpha, vx1);
            vtmp2 = _mm512_mul_pd(valpha, vx2);
            vtmp3 = _mm512_mul_pd(valpha, vx3);

            int r = 0;
            if(misalignrow != 0) {
                myA = A(0, col);
                _mm_prefetch((const char *)&Y[0], _MM_HINT_ET0);
                _mm_prefetch((const char *)&myA[0 * lda], _MM_HINT_T0);
                _mm_prefetch((const char *)&myA[1 * lda], _MM_HINT_T0);
                _mm_prefetch((const char *)&myA[2 * lda], _MM_HINT_T0);
                _mm_prefetch((const char *)&myA[3 * lda], _MM_HINT_T0);
                _mm_prefetch((const char *)&myA[(CLBLK + 0) * lda], _MM_HINT_T1);
                _mm_prefetch((const char *)&myA[(CLBLK + 1) * lda], _MM_HINT_T1);
                _mm_prefetch((const char *)&myA[(CLBLK + 2) * lda], _MM_HINT_T1);
                _mm_prefetch((const char *)&myA[(CLBLK + 3) * lda], _MM_HINT_T1);
                for(r = localtid * misalignrow; r < misalignrow; r++) 
                {
                    myA = A(r, col);
                    Y[r]   += prod0 * myA[0] + prod1 * myA[1 * lda] + prod2 * myA[2 * lda] + prod3 * myA[3 * lda];  
                }
            }

            for(r = misalignrow + localtid * 8; r < M; r += thpgr * 8) {
                myA = A(r, col);
                if((M - r) >= 8) {
                    _mm_prefetch((const char *)&Y[r], _MM_HINT_ET0);
                    _mm_prefetch((const char *)&myA[0 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[1 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[2 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[3 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[(CLBLK + 0) * lda], _MM_HINT_T1);
                    _mm_prefetch((const char *)&myA[(CLBLK + 1) * lda], _MM_HINT_T1);
                    _mm_prefetch((const char *)&myA[(CLBLK + 2) * lda], _MM_HINT_T1);
                    _mm_prefetch((const char *)&myA[(CLBLK + 3) * lda], _MM_HINT_T1);
                    #pragma noprefetch Y, myA
                    //vy = _mm512_load_pd(&Y[r]);
                    vy = _mm512_loadunpacklo_pd(vy, Y + r);
                    vy = _mm512_loadunpackhi_pd(vy, Y + r + 8);
                    //va0 = _mm512_load_pd(myA + 0 * lda);
                    va0 = _mm512_loadunpacklo_pd(va0, myA + 0 * lda);
                    va0 = _mm512_loadunpackhi_pd(va0, myA + 8 + 0 * lda);
                    //va1 = _mm512_load_pd(myA + 1 * lda);
                    va1 = _mm512_loadunpacklo_pd(va1, myA + 1 * lda);
                    va1 = _mm512_loadunpackhi_pd(va1, myA + 8 + 1 * lda);
                    //va2 = _mm512_load_pd(myA + 2 * lda);
                    va2 = _mm512_loadunpacklo_pd(va2, myA + 2 * lda);
                    va2 = _mm512_loadunpackhi_pd(va2, myA + 8 + 2 * lda);
                    //va3 = _mm512_load_pd(myA + 3 * lda);
                    va3 = _mm512_loadunpacklo_pd(va3, myA + 3 * lda);
                    va3 = _mm512_loadunpackhi_pd(va3, myA + 8 + 3 * lda);
                    vy = _mm512_fmadd_pd(va0, vtmp0, vy);
                    vy = _mm512_fmadd_pd(va1, vtmp1, vy);
                    vy = _mm512_fmadd_pd(va2, vtmp2, vy);
                    vy = _mm512_fmadd_pd(va3, vtmp3, vy);
            
                    //_mm512_store_pd(Y + r, vy);
                    _mm512_packstorelo_pd(Y + r, vy);
                    _mm512_packstorehi_pd(Y + r + 8, vy);
                } else {
                    _mm_prefetch((const char *)&Y[r], _MM_HINT_ET0);
                    _mm_prefetch((const char *)&myA[0 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[1 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[2 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[3 * lda], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[(CLBLK + 0) * lda], _MM_HINT_T1);
                    _mm_prefetch((const char *)&myA[(CLBLK + 1) * lda], _MM_HINT_T1);
                    _mm_prefetch((const char *)&myA[(CLBLK + 2) * lda], _MM_HINT_T1);
                    _mm_prefetch((const char *)&myA[(CLBLK + 3) * lda], _MM_HINT_T1);
                    int rr = r;
                    for(; r < M; r++) {
                        Y[r]   += prod0 * myA[r - rr + 0] + prod1 * myA[r - rr + lda] + prod2 * myA[r - rr + 2 * lda] + prod3 * myA[r - rr + 3 * lda];  
                    }
                    /*int k = (M - r);
                    __mmask8 maskk = (1 << k) - 1;
                    //vy  = _mm512_mask_load_pd(vy, maskk, &Y[r]);
                    vy  = _mm512_mask_loadunpacklo_pd(vy, maskk, &Y[r]);
                    vy  = _mm512_mask_loadunpacklo_pd(vy, maskk, &Y[r]);
                    //va0 = _mm512_mask_load_pd(va0, maskk, myA + 0 * lda);
                    va0 = _mm512_loadunpacklo_pd(va0, myA + 0 * lda);
                    va0 = _mm512_loadunpackhi_pd(va0, myA + 8 + 0 * lda);
                    //va1 = _mm512_mask_load_pd(va1, maskk, myA + 1 * lda);
                    va1 = _mm512_loadunpacklo_pd(va1, myA + 1 * lda);
                    va1 = _mm512_loadunpackhi_pd(va1, myA + 8 + 1 * lda);
                    //va2 = _mm512_mask_load_pd(va2, maskk, myA + 2 * lda);
                    va2 = _mm512_loadunpacklo_pd(va2, myA + 2 * lda);
                    va2 = _mm512_loadunpackhi_pd(va2, myA + 8 + 2 * lda);
                    //va3 = _mm512_mask_load_pd(va3, maskk, myA + 3 * lda);
                    va3 = _mm512_loadunpacklo_pd(va3, myA + 3 * lda);
                    va3 = _mm512_loadunpackhi_pd(va3, myA + 8 + 3 * lda);
                    vy = _mm512_fmadd_pd(va0, vtmp0, vy);
                    vy = _mm512_fmadd_pd(va1, vtmp1, vy);
                    vy = _mm512_fmadd_pd(va2, vtmp2, vy);
                    vy = _mm512_fmadd_pd(va3, vtmp3, vy);
                    //_mm512_mask_store_pd(Y + r, maskk, vy);
                    _mm512_mask_packstorelo_pd(Y + r, maskk, vy);
                    _mm512_mask_packstorehi_pd(Y + r, maskk, vy);
                    */
                }
            }
        } else {
            for(int c = 0; c < cblk; c++) {
                prod = alpha * X[col + c];
                vx0 = _mm512_extload_pd(X + col + c, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
                vtmp0 = _mm512_mul_pd(valpha, vx0);

                int r = 0;
                if(misalignrow != 0) {
                    myA = A(r, col + c);
                    _mm_prefetch((const char *)&Y[r], _MM_HINT_ET0);
                    _mm_prefetch((const char *)&myA[0], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[lda], _MM_HINT_T1);
                    for(r = localtid * misalignrow; r < misalignrow; r++) 
                    {
                        myA = A(r, col + c);
                        Y[r]   += prod * myA[0];  
                    }
                }

                for(r = misalignrow + localtid * 8; r < M; r += thpgr * 8) {
                    myA = A(r, col + c);
                    _mm_prefetch((const char *)&Y[r], _MM_HINT_ET0);
                    _mm_prefetch((const char *)&myA[0], _MM_HINT_T0);
                    _mm_prefetch((const char *)&myA[lda], _MM_HINT_T1);
                    if((M - r) >= 8) {
                        #pragma noprefetch Y, myA
                        //vy = _mm512_load_pd(&Y[r]);
                        vy = _mm512_loadunpacklo_pd(vy, Y + r);
                        vy = _mm512_loadunpackhi_pd(vy, Y + r + 8);
                        //va0 = _mm512_load_pd(myA);
                        va0 = _mm512_loadunpacklo_pd(va0, myA + 0 * lda);
                        va0 = _mm512_loadunpackhi_pd(va0, myA + 8 + 0 * lda);
                        vy = _mm512_fmadd_pd(va0, vtmp0, vy);

                        //_mm512_store_pd(Y + r, vy);
                        _mm512_packstorelo_pd(Y + r, vy);
                        _mm512_packstorehi_pd(Y + r + 8, vy);
                    } else {
                        int rr = r;
                        for(; r < M; r++) {
                            Y[r]   += prod * myA[r - rr];  
                        }
                        /*int k = (M - r);
                        __mmask8 maskk = (1 << k) - 1;
                        vy = _mm512_mask_load_pd(vy, maskk, &Y[r]);
                        va0 = _mm512_mask_load_pd(va0, maskk, myA);
                        vy = _mm512_fmadd_pd(va0, vtmp0, vy);

                        _mm512_mask_store_pd(Y + r, maskk, vy);*/
                    }
                }
            }
        }
    }

    #undef A
    #undef y
    #undef Y
    #undef X
}

//working version - using intrensic
void dgemv_kernel_T_v2(int M, int N, double alpha, double *A, int lda, double *X, int incx, double beta, double *Y, int incy, int localtid, int thpgr) 
{
    #define A(i,j) A + (i) + (j)*lda
    #define Y(i)   Y + (i)
    #define X(i)   X + (i)

    int row, col;
    double *myA, val;

    for(col = localtid; col < N; col += thpgr) {
        myA = A(0, col);
        val =  0;
                
        for(row = 0; row < M; row++) 
                val   += alpha * myA[row] * X[row];  

        Y[col] = beta * Y[col] + val ;
    }

    #undef A
    #undef y
    #undef Y
    #undef X
}


void magma_dgemv(char transA, int M, int N, double alpha, double *A, int lda, double *X, int incx, double beta, double *Y, int incy) 
{
    #define THREADS_PER_CORE 4
    #define A(i,j) A + (i) + (j)*lda
    #define Y(i)   Y + (i)
    #define X(i)   X + (i)

    double total, tscale, tpragma, tcomp;
    double done;
    int ngroup, thpgr, RWorCL, XBLK, YBLK, nxblk, nyblk, nblk;

    total = dsecnd();

    done = 1.0;
    //set number of group and threads in each group 
    ngroup = 240;//NGRP;//60;
    thpgr = 1;

    tscale = dsecnd();

    //scale Y
    //dscal(&M, (const double *)&beta, (double *)Y, &incy);
    if(transA == 'N') {
        for(int r = 0; r < M; r++)
            Y[r] = beta * Y[r];
    }

    tscale = dsecnd() - tscale;

    double t = dsecnd();

    #pragma omp parallel num_threads(ngroup)
    {
        int mid = omp_get_thread_num();
        int offset;
        offset = 1 + mid * THREADS_PER_CORE; 	
        
        double tmypragma = dsecnd() - t;
        tpragma = dsecnd() - t;
                    
        double *mypY;

        double tt = dsecnd();

        //computation blk by blk
        int xblk, yblk;

        //transA = 'T'
        //0 1 2 3
        //0 1 2 3
        //0 1 2 3
        //0 1 2 3 
        //transA == 'N'
        //0 0 0 0
        //1 1 1 1
        //2 2 2 2
        //3 3 3 3
        //for(int k = mid; k < nblk; k += ngroup) {
            int x, y, localM, localN;
            if(transA == 'T') {
                int ncore = 60;
                int gid = mid / 4;
                if(gid < ncore) {
                    localN = N / ncore + (gid < (N % ncore) ? 1 : 0);
                    int tyblk = gid * (N / ncore) + (gid < (N % ncore) ? gid : (N % ncore));
                    mypY = Y + tyblk;
                
                    dgemv_kernel_T_v2(M, localN, alpha, A(0, tyblk), lda, X, incx, beta, mypY , incy, mid % 4, 4);
                }
                 
            } else if(transA == 'N') {
                //considering unaligned matrix A
                int start = 0;
                int misalignrow = ((64 - (((unsigned long)&A[0]) & 63)) / 8) % 8;
                int rowToDivide = M - misalignrow;
                int ncore = 60;
                int gid = mid / 4;
                if(gid == 0)
                    start = 0;
                else
                    start = misalignrow;

                int m8block = (rowToDivide + 7) / 8;
                int tnblk = (m8block / ncore + (gid < (m8block % ncore) ? 1 : 0));
                int trow = tnblk * 8;
                trow = (gid != 0) ? trow : trow + misalignrow;
                int tstartblk = gid * (m8block / ncore) + (gid < (m8block % ncore) ? gid : (m8block % ncore));
                int tstart = start + tstartblk * 8;
                localM = (tstart + trow) < M ? trow : (M - tstart);
                localN = N;
                if(localM > 0) {
                    mypY = Y + tstart;
                    dgemv_kernel_N_v2(localM, localN, alpha, A(tstart, 0), lda, X, incx, done, mypY , incy, mid % 4, 4); 
                }
               
            }

        tcomp = dsecnd() - tt;
    }

    total = dsecnd() - total;
    /*if(transA == 'N')
        printf("Non Transpose ");
    else if(transA == 'T') 
        printf("Transpose ");
     else
         printf("WRONG\n");

    printf("M: %d N: %d tscale: %4.2lf tpragma: %4.2lf tcomp: %4.2lf overhead: %4.2lf, sum: %4.2lf total: %4.2lf flop: %4.2lf\n", M, N, tscale * 1000, tpragma * 1000, tcomp * 1000, (tscale + tpragma) * 1000, (tscale + tpragma + tcomp) * 1000, total * 1000, (2.0 * M * N * 1e-9) / total);
    */
    #undef A
    #undef Y
    #undef partialY
    #undef X
}

#endif


void call_dgemv(magma_mic_dgemv_param param)
{
    magma_trans_t transa;
    magma_int_t m, n, lda, incx, incy;
    double alpha, beta, *a, *x, *y;
    
    transa = param.transa;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    x      = (double *)param.x;
    incx   = param.incx;
    beta   = param.beta;
    y      = (double *)param.y;
    incy   = param.incy;
    
    //printf("DGEMV: %c %c %d %d %d %f 0x%lx %d 0x%lx %d %f 0x%lx %d\n", transa, transb, m, n, k, alpha, (off_t)a, lda, (off_t)b, ldb, beta, (off_t)c, ldc);
    
    #ifdef PRECISION_d
    char trans;
    if(lapack_const(transa)[0] == 'T' || lapack_const(transa)[0] == 't')
        trans = 'T';
    else if(lapack_const(transa)[0] == 'N' || lapack_const(transa)[0] == 'n')
        trans = 'N';
    else {

        dgemv( lapack_const(transa), &m, &n, (const double *)&alpha,
                (double *)a, &lda, (double *)x, &incx,
                (const double *)&beta, (double *)y, &incy);
        return;
    }
    
    magma_dgemv(trans, m, n, alpha,
           (double *)a, lda, (double *)x, incx,
           beta, (double *)y, incy);

    #else
        dgemv( lapack_const(transa), &m, &n, (const double *)&alpha,
               (double *)a, &lda, (double *)x, &incx,
            (const double *)&beta, (double *)y, &incy);
    #endif
}

//=========================================================================================
#ifdef PRECISION_d
void dgemv_kernel_NT_v3(int M, int N, double alpha, double *A, int lda, double *XN, int incx, double beta, double *YN, int incy, double *XT, double *YT, int localid, int thpgr) 
{
    #define A(i,j) A + (i) + (j)*lda
    #define Y(i)   Y + (i)
    #define X(i)   X + (i)

    int row, col;

    double t = dsecnd();

    int cBLK = 4;
    int L1PF = 8;
    int L2PF = 32;
    int m8 = (M % 8 == 0) ? M : (M - 1) / 8 * 8;
    double *myA[cBLK], *myY;
    double prod0, prod1, prod2, prod3, yt0, yt1, yt2, yt3;
    double zero = 0.0;
    
    __m512d va0, va1, va2, va3, vy, vtmp0, vtmp1, vtmp2, vtmp3, valpha, vx0, vx1, vx2, vx3, vyt0, vyt1, vyt2, vyt3, vxt;

    valpha = _mm512_extload_pd(&alpha, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);

    for(col = 0; col < N; col += cBLK) {
        int cblk = (N - col) < cBLK ? (N - col) : cBLK;
        if(cblk >= cBLK) {
            _mm_prefetch((const char *)(XN + col), _MM_HINT_T0);
            _mm_prefetch((const char *)(YT + col), _MM_HINT_T0);

            myA[0] = A(0, col + 0);
            myA[1] = A(0, col + 1);
            myA[2] = A(0, col + 2);
            myA[3] = A(0, col + 3);
       
            //For N 
            vx0 = _mm512_extload_pd(XN + col + 0, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vx1 = _mm512_extload_pd(XN + col + 1, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vx2 = _mm512_extload_pd(XN + col + 2, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vx3 = _mm512_extload_pd(XN + col + 3, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);

            //For T
            vyt0 = _mm512_extload_pd(&zero, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vyt1 = _mm512_extload_pd(&zero, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vyt2 = _mm512_extload_pd(&zero, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            vyt3 = _mm512_extload_pd(&zero, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
            
            vtmp0 = _mm512_mul_pd(valpha, vx0);
            vtmp1 = _mm512_mul_pd(valpha, vx1);
            vtmp2 = _mm512_mul_pd(valpha, vx2);
            vtmp3 = _mm512_mul_pd(valpha, vx3);
            
      
            yt0 = yt1 = yt2 = yt3 = 0;
            
            _mm_prefetch((const char *)(YN), _MM_HINT_ET0);
            _mm_prefetch((const char *)(myA[0]), _MM_HINT_T0);
            _mm_prefetch((const char *)(myA[1]), _MM_HINT_T0);
            _mm_prefetch((const char *)(myA[2]), _MM_HINT_T0);
            _mm_prefetch((const char *)(myA[3]), _MM_HINT_T0);

            for(row = 0; row < M; row += 8) {
                if((M - row) >= 8) {
                    _mm_prefetch((const char *)(YN + row + L1PF), _MM_HINT_ET0);
                    _mm_prefetch((const char *)(myA[0] + row + L1PF), _MM_HINT_T0);
                    _mm_prefetch((const char *)(myA[1] + row + L1PF), _MM_HINT_T0);
                    _mm_prefetch((const char *)(myA[2] + row + L1PF), _MM_HINT_T0);
                    _mm_prefetch((const char *)(myA[3] + row + L1PF), _MM_HINT_T0);
                    //prefetch
                    _mm_prefetch((const char *)(myA[0] + row + cBLK * lda), _MM_HINT_T1);
                    _mm_prefetch((const char *)(myA[1] + row + cBLK * lda), _MM_HINT_T1);
                    _mm_prefetch((const char *)(myA[2] + row + cBLK * lda), _MM_HINT_T1);
                    _mm_prefetch((const char *)(myA[3] + row + cBLK * lda), _MM_HINT_T1);

                    //compute
                    #pragma noprefetch myA[0], myA[1], myA[2], myA[3]
                    #pragma noprefetch YN
                    //For T
                    //vxt  = _mm512_load_pd(&XT[r]);
                    vxt = _mm512_loadunpacklo_pd(vxt, XT + row);
                    vxt = _mm512_loadunpackhi_pd(vxt, XT + row + 8);
                    
                    //For N
                    //vy = _mm512_load_pd(&Y[row]);
                    vy = _mm512_loadunpacklo_pd(vy, YN + row);
                    vy = _mm512_loadunpackhi_pd(vy, YN + row + 8);

                    //va0 = _mm512_load_pd(myA[0] + row);
                    va0 = _mm512_loadunpacklo_pd(va0, myA[0] + row);
                    va0 = _mm512_loadunpackhi_pd(va0, myA[0] + row + 8);
                    //va1 = _mm512_load_pd(myA[1] + row);
                    va1 = _mm512_loadunpacklo_pd(va1, myA[1] + row);
                    va1 = _mm512_loadunpackhi_pd(va1, myA[1] + row + 8);
                    //va2 = _mm512_load_pd(myA[2] + row);
                    va2 = _mm512_loadunpacklo_pd(va2, myA[2] + row);
                    va2 = _mm512_loadunpackhi_pd(va2, myA[2] + row + 8);
                    //va3 = _mm512_load_pd(myA[3] + row);
                    va3 = _mm512_loadunpacklo_pd(va3, myA[3] + row);
                    va3 = _mm512_loadunpackhi_pd(va3, myA[3] + row + 8);

                    //For N
                    vy = _mm512_fmadd_pd(va0, vtmp0, vy);
                    vy = _mm512_fmadd_pd(va1, vtmp1, vy);
                    vy = _mm512_fmadd_pd(va2, vtmp2, vy);
                    vy = _mm512_fmadd_pd(va3, vtmp3, vy);

                    //For T
                    vyt0 = _mm512_fmadd_pd(va0, vxt, vyt0);
                    vyt1 = _mm512_fmadd_pd(va1, vxt, vyt1);
                    vyt2 = _mm512_fmadd_pd(va2, vxt, vyt2);
                    vyt3 = _mm512_fmadd_pd(va3, vxt, vyt3);
                    
                    //For N
                    // _mm512_store_pd(Y + row, vy);
                    _mm512_packstorelo_pd(YN + row, vy);
                    _mm512_packstorehi_pd(YN + row + 8, vy);
                    

                } else {

                    prod0 = alpha * XN[col + 0];
                    prod1 = alpha * XN[col + 1];
                    prod2 = alpha * XN[col + 2];
                    prod3 = alpha * XN[col + 3];
                    _mm_prefetch((const char *)(myA[0] + row + cBLK * lda), _MM_HINT_T1);
                    _mm_prefetch((const char *)(myA[1] + row + cBLK * lda), _MM_HINT_T1);
                    _mm_prefetch((const char *)(myA[2] + row + cBLK * lda), _MM_HINT_T1);
                    _mm_prefetch((const char *)(myA[3] + row + cBLK * lda), _MM_HINT_T1);

                    //#pragma noprefetch myA[0], myA[1], myA[2], myA[3], YN, XT
                    for(int r = row; r < M; r++) {
                        //For N
                        double sum = prod0 * myA[0][r] + prod1 * myA[1][r] + prod2 * myA[2][r] + prod3 * myA[3][r];  
                        YN[r] += sum;

                        //For T
                        yt0   += XT[r] * myA[0][r];
                        yt1   += XT[r] * myA[1][r];
                        yt2   += XT[r] * myA[2][r];
                        yt3   += XT[r] * myA[3][r];
                    }
 
                }
            }

            //For T
            YT[col + 0] += alpha * (yt0 + _mm512_reduce_add_pd(vyt0));
            YT[col + 1] += alpha * (yt1 + _mm512_reduce_add_pd(vyt1));
            YT[col + 2] += alpha * (yt2 + _mm512_reduce_add_pd(vyt2));
            YT[col + 3] += alpha * (yt3 + _mm512_reduce_add_pd(vyt3));

        } else {
            for(int c = 0; c < cblk; c++) {
                _mm_prefetch((const char *)(XN + col + c), _MM_HINT_T0);
                _mm_prefetch((const char *)(YT + col + c), _MM_HINT_T0);
                myA[0] = A(0, col + c);
                
                vx0 = _mm512_extload_pd(XN + col + c, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
                vtmp0 = _mm512_mul_pd(valpha, vx0);
                
                //For T
                vyt0 = _mm512_extload_pd(&zero, _MM_UPCONV_PD_NONE, _MM_BROADCAST_1X8, _MM_HINT_NONE);
                for(row = 0; row < L1PF; row += 8) { 
                    _mm_prefetch((const char *)(YN + row), _MM_HINT_ET0);
                    _mm_prefetch((const char *)(XT + row), _MM_HINT_T0);
                    _mm_prefetch((const char *)(myA[0] + row), _MM_HINT_T0);
                }
       
                yt0 = 0.0;
                
                for(row = 0; row < M; row += 8) {
                    if((M - row) >= 8) {
                        _mm_prefetch((const char *)(YN + row + L1PF), _MM_HINT_ET0);
                        _mm_prefetch((const char *)(XT + row + L1PF), _MM_HINT_T0);
                        _mm_prefetch((const char *)(XT + row + L2PF), _MM_HINT_T1);
                        _mm_prefetch((const char *)(myA[0] + row + L1PF), _MM_HINT_T0);
                        _mm_prefetch((const char *)(myA[0] + row + lda), _MM_HINT_T1);

                        //compute
                        #pragma noprefetch myA[0], YN, XT
                        //vy = _mm512_load_pd(&Y[row]);
                        vy = _mm512_loadunpacklo_pd(vy, YN + row);
                        vy = _mm512_loadunpackhi_pd(vy, YN + row + 8);

                        //va0 = _mm512_load_pd(myA[0] + row);
                        va0 = _mm512_loadunpacklo_pd(va0, myA[0] + row);
                        va0 = _mm512_loadunpackhi_pd(va0, myA[0] + row + 8);

                        vy = _mm512_fmadd_pd(va0, vtmp0, vy);

                        // _mm512_store_pd(Y + row, vy);
                        _mm512_packstorelo_pd(YN + row, vy);
                        _mm512_packstorehi_pd(YN + row + 8, vy);
                        
                        //For T
                        //vxt  = _mm512_load_pd(&XT[r]);
                        vxt = _mm512_loadunpacklo_pd(vxt, XT + row);
                        vxt = _mm512_loadunpackhi_pd(vxt, XT + row + 8);

                        vyt0 = _mm512_fmadd_pd(va0, vxt, vyt0);
                    } else {
                        prod0 = alpha * XN[col + c];
                        _mm_prefetch((const char *)(myA[0] + row + lda), _MM_HINT_T1);
                        for(int r = row; r < M; r++) {
                            YN[r]   += prod0 * myA[0][r];  
                            
                            //For T
                            yt0   += (XT[r] * myA[0][r]);
                        }
 
                    }
                }
                
                YT[col + c] += alpha * (yt0 + _mm512_reduce_add_pd(vyt0));

            }
        }
 
    }

    #undef A
    #undef y
    #undef Y
    #undef X
}

void magma_dsymv(char LWUP, int N, double alpha, double *A, int lda, double *X, int incx, double beta, double *Y, int incy, int nxshift, double *partialY) 
{
    #define THREADS_PER_CORE 4
    #define A(i,j) A + (i) + (j)*lda
    #define Y(i)   Y + (i)
    #define partialY(i, j)   partialY + (i) + (j) * lda
    #define X(i)   X + (i)

    double total, talloc, tscale, tpragma1, tpragma2, tpragma3, tsymv, tinit, tcomp, tadd;
    double done;
    int allocflag, nthr, ngroup, thpgr, m8block, XBLK, YBLK, blkd, nblk, symvblk;

    total = dsecnd();

    done = 1.0;
    //set number of group and threads in each group 
    ngroup = 60;//NGRP;
    nthr = 240;
    thpgr = 1;
    m8block = (N + 7) / 8;
    blkd= symvblk = 60;
    nblk = (blkd * (blkd + 1)) / 2 - blkd;
  
    tscale = dsecnd();
    double tmpval[8];
    for(int i = 0; i < nxshift; i++) {
        tmpval[i] = X[i];
        X[i] = 0;
    }
 
    //scale Y
    //dscal(&M, (const double *)&beta, (double *)Y, &incy);
    
    for(int r = 0; r < N; r++)
        Y[r] = beta * Y[r];
    
    tscale = dsecnd() - tscale;

    double t = dsecnd();

    #pragma omp parallel num_threads(nthr)
    {
        int mid = omp_get_thread_num();
        int gid = mid / 4;
        int ncore = 60;

        tpragma1 = dsecnd() - t;

        double *mypY, *mypTY;
        
       
        /*************** init ****************/ 
        //set partialY to zero
        double ttinit = dsecnd();
        if(mid % 4 == 0) {
            mypY = partialY(0, gid);
            double zero = 0.0;
            for(int r = 0; r < N; r++)
            mypY[r] = zero * mypY[r];
        }
        tinit = dsecnd() - ttinit;
        /*************** init ****************/ 

        /*************** SYMV diagonal block ****************/ 
       
        double ttsymv = dsecnd();

        //do SYMV on diagonal block
        if(mid % 4 == 0)
        {
            mypY = partialY(0, gid);
            for(int i = gid; i < symvblk; i += ncore) 
            {
                int mynblk = (m8block / blkd + (i < (m8block % blkd) ? 1 : 0));
                int myN = mynblk * 8;
                int mystartblk = i * (m8block / blkd) + (i < (m8block % blkd) ? i : (m8block % blkd));
                int mystartN = mystartblk * 8;
                int localN = ((mystartN + myN) < N) ? myN : (N - mystartN);
                if(localN > 0) {
                    mypY = partialY(mystartN, gid);//Y + mystartN;
                    dsymv("L", &localN, &alpha, A(mystartN, mystartN), &lda, X(mystartN), &incx, &done, mypY , &incy); 
                }
            } 
        }

        tsymv = dsecnd() - ttsymv;

        /*************** SYMV diagonal block ****************/ 
        
        ncore = 60;
     
        mypY = partialY(0, mid);

        /******** computation non diagonal block ***********/

        double ttcomp = dsecnd();

        int i, j, k, kk, blk_in_cb, myBlkSum, curNBlk, colsum, row, rowsum;
        myBlkSum = colsum = 0;

        if(mid % 4 == 0 && gid < ncore) {
            kk = gid;
            for(int cb = 0; cb < blkd; cb++) {
                colsum += (cb + 1);
                blk_in_cb = blkd - cb - 1;  
                myBlkSum += blk_in_cb;

                if(kk >= myBlkSum)
                    continue;
                    
                k = kk + colsum;
                kk = kk + ncore;

                j = k / blkd;
                i = k % blkd;
                
                int myniblk = (m8block / blkd + (i < (m8block % blkd) ? 1 : 0));
                int myM = myniblk * 8;
                int myistartblk = i * (m8block / blkd) + (i < (m8block % blkd) ? i : (m8block % blkd));
                int mystartM = myistartblk * 8;
                int localM = ((mystartM + myM) < N) ? myM : (N - mystartM);
                    
                int mynjblk = (m8block / blkd + (j < (m8block % blkd) ? 1 : 0));
                int myN = mynjblk * 8;
                int myjstartblk = j * (m8block / blkd) + (j < (m8block % blkd) ? j : (m8block % blkd));
                int mystartN = myjstartblk * 8;
                int localN = ((mystartN + myN) < N) ? myN : (N - mystartN);
                    
                double *mypY  = partialY(mystartM, gid);
                double *mypTY = partialY(mystartN, gid);

                //printf("k: %d kk: %d xblk: %d yblk: %d\n", k, kk, xblk, yblk);
                double tb = dsecnd();
               
                if(localM > 0 && localN > 0) { 
                    dgemv_kernel_NT_v3(localM, localN, alpha, A(mystartM, mystartN), lda, X(mystartN), incx, done, mypY, incy, X(mystartM), mypTY, mid % 4, 1); 
                }
                tb = dsecnd() - tb;
            }
        }

        tcomp = dsecnd() - ttcomp;
    }

    double ta = dsecnd();
   
    #pragma omp parallel num_threads(nthr)
    {
        int mid = omp_get_thread_num();
        
        tpragma3 = dsecnd() - ta;

        int n8 = (N / nthr + 7) / 8 * 8;
        n8 = (n8 == 0) ? N : n8;
        for(int i = mid * n8; i < N; i += n8 * nthr) {
            int nele = (N - i) < n8 ? (N - i) : n8;

            /*for(int g = 0; g < ngroup; g++) {
                double *psum = partialY(i, g);
                #pragma ivdep
                #pragma simd
                for(int r = 0; r < nele; r++) {
                    Y[i + r] =  Y[i + r] + psum[r];
                }
            }*/
            __m512d vy, vpy;
            for(int r = 0; r < nele; r+= 8) {
                _mm_prefetch((const char *)&Y[i + r], _MM_HINT_T0);
                if((nele - r) >= 8) {
                    vy = _mm512_loadunpacklo_pd(vy, &Y[i + r]);
                    vy = _mm512_loadunpackhi_pd(vy, &Y[i+ r + 8]);
                }

                for(int g = 0; g < ngroup; g++) {
                    double *pY = partialY(i, g);
                    _mm_prefetch((const char *)&pY[r], _MM_HINT_T0);
                    _mm_prefetch((const char *)&pY[r + lda], _MM_HINT_T1);
                    if((nele - r) >= 8) {
                        vpy = _mm512_loadunpacklo_pd(vpy, &pY[r]);
                        vpy = _mm512_loadunpackhi_pd(vpy, &pY[r + 8]);
                        vy = _mm512_add_pd(vy, vpy);
                    } else {
                        for(int rr = r; rr < nele; rr++)
                            Y[i + rr] =  Y[i + rr] + pY[rr];
                    } 
                }

                if((nele - r) >= 8) {
                    _mm512_packstorelo_pd(&Y[i + r], vy);
                    _mm512_packstorehi_pd(&Y[i + r + 8], vy);
                }
            }
        }
    }

    tadd = dsecnd() - ta;
    //restore X value
    for(int i = 0; i < nxshift; i++) {
        X[i] = tmpval[i];
    }


    double tfree = dsecnd();
    tfree = dsecnd() - tfree;

    total = dsecnd() - total;

    //printf("talloc: %4.2lf tscale: %4.2lf tpragma1: %4.2lf tpragma3: %4.2lf pragma: %4.2lf tinit: %4.2lf tsymv: %4.2lf tcomp: %4.2lf tadd: %4.2lf tfree: %4.2lf overhead: %4.2lf sum: %4.2lf total: %4.2lf\n", talloc * 1000, tscale * 1000, tpragma1 * 1000, tpragma3 * 1000, (tpragma1 + tpragma3) * 1000, tinit * 1000, tsymv * 1000, tcomp * 1000, tadd * 1000, tfree * 1000, (tadd + tpragma1) * 1000, (talloc + tscale + tpragma1 + tinit + tsymv + tcomp + tadd + tfree) * 1000, total * 1000);

    #undef A
    #undef Y
    #undef partialY
    #undef X

}

#endif

void call_dsymv(magma_mic_dsymv_param param)
{
    magma_uplo_t uplo;
    magma_int_t n, lda, incx, incy;
    double alpha, beta, *a, *x, *y;
    
    uplo   = param.uplo;
    n      = param.n;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    x      = (double *)param.x;
    incx   = param.incx;
    beta   = param.beta;
    y      = (double *)param.y;
    incy   = param.incy;
    
    dsymv( lapack_const(uplo), &n, (const double *)&alpha,
           (double *)a, &lda, (double *)x, &incx,
           (const double *)&beta, (double *)y, &incy);
}

void call_dsymv_for_trd(magma_mic_dsymv_for_trd_param param)
{
    magma_uplo_t uplo;
    magma_int_t n, lda, incx, incy, symvshift;
    double alpha, beta, *a, *x, *y, *partialY;
    
    uplo   = param.uplo;
    n      = param.n;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    x      = (double *)param.x;
    incx   = param.incx;
    beta   = param.beta;
    y      = (double *)param.y;
    incy   = param.incy;
    symvshift   = param.symvshift;
    partialY   = (double *)param.partialY;

    #ifdef PRECISION_d
    char UPLO;
    if(lapack_const(uplo)[0] == 'L' || lapack_const(uplo)[0] == 'l') {
        UPLO = 'L';

        magma_dsymv(UPLO, n, alpha,
               (double *)a, lda, (double *)x, incx,
            beta, (double *)y, incy, symvshift, (double *)partialY);
    } else {
    
        dsymv( lapack_const(uplo), &n, (const double *)&alpha,
               (double *)a, &lda, (double *)x, &incx,
            (const double *)&beta, (double *)y, &incy);
    }

    #else
 
        dsymv( lapack_const(uplo), &n, (const double *)&alpha,
               (double *)a, &lda, (double *)x, &incx,
            (const double *)&beta, (double *)y, &incy);

    #endif
}

//=========================================================================================
void call_dsymv2(magma_mic_dsymv2_param param)
{
    magma_uplo_t uplo;
    magma_int_t n, lda, incx, incy;
    double alpha, beta, *a, *x, *y;
    
    uplo   = param.uplo;
    n      = param.n;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    x      = (double *)param.x;
    incx   = param.incx;
    beta   = param.beta;
    y      = (double *)param.y;
    incy   = param.incy;
    
    dsymv( lapack_const(uplo), &n, (const double *)&alpha,
           (double *)a, &lda, (double *)x, &incx,
           (const double *)&beta, (double *)y, &incy);
}

//=========================================================================================
void call_dtrsm(magma_mic_dtrsm_param param)
{
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m, n, lda, ldb;
    double alpha, *a, *b;
    
    side   = param.side;
    uplo   = param.uplo;
    transa = param.transa;
    diag   = param.diag;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    b      = (double *)param.b;
    ldb    = param.ldb;
    
    //printf("DTRSM: %c %c %c %c %d %d %f 0x%lx %d 0x%lx %d\n", side, uplo, transa, diag, m, n, alpha, (off_t)a, lda, (off_t)b, ldb);
    dtrsm( lapack_const(side), lapack_const(uplo), lapack_const(transa), lapack_const(diag),
           &m, &n, (const double *)&alpha, (double *)a, &lda,
           (double *)b, &ldb);
}

//=========================================================================================
void call_dtrsv(magma_mic_dtrsv_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_diag_t diag;
    magma_int_t n, lda, incx;
    double alpha, *a, *dx;
    
    uplo  = param.uplo;
    trans = param.trans;
    diag  = param.diag;
    n     = param.n;
    a     = (double *)param.a;
    lda   = param.lda;
    dx    = (double *)param.dx;
    incx  = param.incx;
    
    dtrsv( lapack_const(uplo), lapack_const(trans), lapack_const(diag),
           &n, (double *)a, &lda, (double *)dx, &incx);
}

//=========================================================================================
void call_dtrmv(magma_mic_dtrmv_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_diag_t diag;
    magma_int_t n, lda, incx;
    double alpha, *a, *dx;
    
    uplo  = param.uplo;
    trans = param.trans;
    diag  = param.diag;
    n     = param.n;
    a     = (double *)param.a;
    lda   = param.lda;
    dx    = (double *)param.dx;
    incx  = param.incx;
    
    dtrmv( lapack_const(uplo), lapack_const(trans), lapack_const(diag),
           &n, (double *)a, &lda, (double *)dx, &incx);
}

//=========================================================================================
void call_dtrmm(magma_mic_dtrmm_param param)
{
    magma_side_t  side;
    magma_uplo_t  uplo;
    magma_trans_t transa;
    magma_diag_t  diag;
    magma_int_t m, n, lda, ldb;
    double alpha, *a, *b;

    side   = param.side;
    uplo   = param.uplo;
    transa = param.transa;
    diag   = param.diag;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    b      = (double *)param.b;
    ldb    = param.ldb;

    //printf("DTRMM: %c %c %c %c %d %d %f 0x%lx %d 0x%lx %d\n", side, uplo, transa, diag, m, n, alpha, (off_t)a, lda, (off_t)b, ldb);
    dtrmm( lapack_const(side), lapack_const(uplo), lapack_const(transa), lapack_const(diag),
           &m, &n, (const double *)&alpha, (double *)a, &lda,
           (double *)b, &ldb);
}

//=========================================================================================
//magmablas our dsyrk Azzam
//=========================================================================================
void magmablas_dsyrk_mic0(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magma_int_t nb,
    double alpha, double *a, magma_int_t lda, magma_int_t aoff,
    double beta,  double *c, magma_int_t ldc, magma_int_t offset)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    double cbeta  = MAGMA_D_MAKE( beta,  0. );
    double calpha = MAGMA_D_MAKE( alpha, 0. );

    magma_int_t m, ib, ioff;
    magma_int_t blockoffset = offset % nb;

    // loop over all blocks and does A*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        // C[i:n,i] += A[i:n,0] * A[i,0]'
        m = n - i;
        dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
               (const double *)&calpha, (double *)(dA(i,0)),       &lda,
                                               (double *)(dA(i,0)),       &lda,
               (const double *)&cbeta,  (double *)(dC(ioff,ioff)), &ldc );
        blockoffset = 0;
    }
    
    #undef dA
    #undef dC
}

//=========================================================================================
//magmablas our dsyrk version2
//=========================================================================================
void magmablas_dsyrk_mic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magma_int_t nb,
    double alpha, double *a, magma_int_t lda, magma_int_t aoff,
    double beta,  double *c, magma_int_t ldc, magma_int_t offset)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    double cbeta  = MAGMA_D_MAKE( beta,  0. );
    double calpha = MAGMA_D_MAKE( alpha, 0. );

    //if (n <= 3840)
    //        nb = 1200;
    //else
    //  nb = 960;

    magma_int_t m, ib, ioff;
    magma_int_t blockoffset = offset % nb;

    if (n <= 8640) {
        // loop over all blocks and does A*A'
        // blockoffset is offset within first block; for subsequent blocks it is 0
        for( magma_int_t i = 0; i < n; i += ib ) {
            ib     = min( nb-blockoffset, n-i );  // block size
            ioff   = i + offset;                  // global index in parent matrix
            // C[i:n,i] += A[i:n,0] * A[i,0]'
            m = n - i;
            dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
                            (const double *)&calpha, (double *)(dA(i,0)),       &lda,
                                                            (double *)(dA(i,0)),       &lda,
                            (const double *)&cbeta,  (double *)(dC(ioff,ioff)), &ldc );
            blockoffset = 0;
        }
    } else {
        magma_int_t i_960 = n / (2 * 960);
        magma_int_t ngemm = i_960 * 960;
        magma_int_t nrema = n - ngemm;
        //gemm for square block
        dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &ngemm, &nrema, &k,
                        (const double *)&calpha, (double *)(dA(nrema, 0)), &lda,
                                                        (double *)(dA(0, 0)),     &lda,
                        (const double *)&cbeta,  (double *)(dC(nrema, 0)), &ldc );

        //two syrk call
        magmablas_dsyrk_mic(MagmaLower, MagmaNoTrans,
                        nrema, k, nb, alpha, a, lda, 0,
                        beta, c, ldc, 0);

        magmablas_dsyrk_mic(MagmaLower, MagmaNoTrans,
                        ngemm, k, nb, alpha, dA(nrema, 0), lda, 0,
                        beta, dC(nrema, nrema), ldc, 0);
    }
    
    #undef dA
    #undef dC
}

//=========================================================================================
void call_dsyrk(magma_mic_dsyrk_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldc;
    double alpha, beta;
    double *a, *c;

    uplo  = param.uplo;
    trans = param.trans;
    n     = param.n;
    k     = param.k;
    alpha = param.alpha;
    a     = (double *)param.a;
    lda   = param.lda;
    beta  = param.beta;
    c     = (double *)param.c;
    ldc   = param.ldc;

    //printf("DSYRK: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo, trans, n, k, alpha, (off_t)a, lda, beta, (off_t)c, ldc);

    // call MKL dsyrk
    //dsyrk( lapack_const(uplo), lapack_const(trans),
    //       &n, &k, &alpha, (double *)a, &lda,
    //       &beta, (double *)c, &ldc);
   
     
    magma_int_t nb = 960;
    magmablas_dsyrk_mic(MagmaLower, MagmaNoTrans,
                     n, k, nb, alpha, a, lda, 0,
                     beta, c, ldc, 0);
}

//=========================================================================================
void magmablas_dsyrk_mmic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k,
    double alpha, double *a, magma_int_t lda, magma_int_t aoff,
    double beta,  double *c, magma_int_t ldc, magma_int_t offset,
    magma_int_t nmic, magma_int_t nb, magma_int_t my_id)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    double cbeta  = MAGMA_D_MAKE( beta,  0. );
    double calpha = MAGMA_D_MAKE( alpha, 0. );

    magma_int_t rows, ib, ioff, iblock, idev, di, s;

    // loop over all blocks
    // Faster to have two loops: first does A*B', second does B*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    magma_int_t blockoffset = offset % nb;
    double tt = 0;
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        iblock = (ioff / nb) / nmic;          // local block id
        idev   = (ioff / nb) % nmic;          // device with this block
        di     = iblock*nb + blockoffset;     // local index in parent matrix

        // C[i:n,i] += A[i:n,0] * B[i,0]'
        //printf( "dgemm  n=%4d, ib=%4d, k=%4d, i=%4d\n", n-i, ib, k, i );
        if (idev == my_id) {
            rows = n - i;
            dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &rows, &ib, &k,
                   (const double *)&calpha, (double *)dA(i,0),     &lda,
                                                   (double *)dA(i,0),     &lda,
                   (const double *)&cbeta,  (double *)dC(ioff,di), &ldc);
        }

        blockoffset = 0;
    }
    
    #undef dA
    #undef dC
}

//=========================================================================================
void call_dsyrk_mmic(magma_mic_dsyrk_mmic_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldb, ldc, aoff, boff, offset, nb, my_id, nmic;
    double alpha, beta;
    double *a, *b, *c;

    uplo   = param.uplo;
    trans  = param.trans;
    n      = param.n;
    k      = param.k;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    aoff   = param.aoff;
    beta   = param.beta;
    c      = (double *)param.c;
    ldc    = param.ldc;
    offset = param.offset;
    nmic   = param.nmic;
    nb     = param.nb;
    my_id  = param.my_id;

    //printf("DSYRK_MMIC: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo, trans, n, k, alpha, (off_t)a, lda, beta, (off_t)c, ldc);

    magmablas_dsyrk_mmic(
        uplo, trans, n, k,
        alpha, a, lda, aoff,
        beta, c, ldc, offset,
        nmic, nb, my_id);
}

//=========================================================================================
//magmablas our dsyr2k Azzam
//=========================================================================================
void magmablas_dsyr2k_mic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magma_int_t nb,
    double alpha,
    double *a, magma_int_t lda,
    double *b, magma_int_t ldb,
    double beta,
    double *c, magma_int_t ldc)
{
    #define dA(i, j) (a + (i) + (j)*lda)
    #define dB(i, j) (b + (i) + (j)*ldb)
    #define dC(i, j) (c + (i) + (j)*ldc)

    const double c_one = MAGMA_D_ONE;
    double cbeta    = MAGMA_D_MAKE( beta, 0. );
    double cnjalpha = MAGMA_D_CNJG( alpha );

    magma_int_t m, ib;
    // loop over all blocks and does A*A'
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb, n-i );  // block size
        m = n - i;
        //printf("voici m %d     n %d    k %d \n",m,ib,k);
        // C[i:n,i] += A[i:n,0] * A[i,0]'
        dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
               (const double *)&alpha, (double *)(dA(i,0)), &lda,
                                              (double *)(dB(i,0)), &ldb,
               (const double *)&cbeta, (double *)(dC(i,i)), &ldc );

        // C[i:n,i] += A[i:n,0] * A[i,0]'
        dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
               (const double *)&cnjalpha, (double *)(dB(i,0)), &ldb,
                                                 (double *)(dA(i,0)), &lda,
               (const double *)&c_one,    (double *)(dC(i,i)), &ldc );
    }
    
    #undef dA
    #undef dB
    #undef dC
}

//=========================================================================================
void call_dsyr2k(magma_mic_dsyr2k_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldb, ldc;
    double alpha;
    double beta;
    double *a, *b, *c;

    uplo  = param.uplo;
    trans = param.trans;
    n     = param.n;
    k     = param.k;
    alpha = param.alpha;
    a     = (double *)param.a;
    lda   = param.lda;
    b     = (double *)param.b;
    ldb   = param.ldb;
    beta  = param.beta;
    c     = (double *)param.c;
    ldc   = param.ldc;

    //printf("DSYR2K: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo,trans, n,k, alpha, (off_t)a,lda, beta, (off_t)c, ldc);
   
    if (uplo == MagmaUpper) {
           dsyr2k( lapack_const(uplo), lapack_const(trans),
                   &n, &k, (double *)&alpha,
                           (double *)a, &lda,
                           (double *)b, &ldb,
                   &beta,  (double *)c, &ldc);
    } else {
           magma_int_t nb = 960;
           magmablas_dsyr2k_mic( MagmaLower, MagmaNoTrans,
                           n, k, nb, alpha, a, lda,
                           b, ldb,
                           beta, c, ldc);
    }
}

//=========================================================================================
//magmablas our dsyr2k_mmic Azzam
//=========================================================================================
void magmablas_dsyr2k_mmic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k,
    double alpha,
    double *a, magma_int_t lda, magma_int_t aoff,
    double *b, magma_int_t ldb, magma_int_t boff,
    double beta,
    double *c, magma_int_t ldc,  magma_int_t offset,
    magma_int_t nmic, magma_int_t nb, magma_int_t my_id)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dB(i, j) (b + (i) + (j)*ldb + (boff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    const double c_one = MAGMA_D_ONE;
    double cbeta = MAGMA_D_MAKE( beta, 0. );


    magma_int_t rows, ib, ioff, iblock, idev, di, s;

    // loop over all blocks
    // Faster to have two loops: first does A*B', second does B*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    magma_int_t blockoffset = offset % nb;
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        iblock = (ioff / nb) / nmic;          // local block id
        idev   = (ioff / nb) % nmic;          // device with this block
        di     = iblock*nb + blockoffset;     // local index in parent matrix

        // C[i:n,i] += A[i:n,0] * B[i,0]'
        //printf( "dgemm  n=%4d, ib=%4d, k=%4d, i=%4d\n", n-i, ib, k, i );
        if (idev == my_id) {
            rows = n - i;
            dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &rows, &ib, &k,
                   (const double *)&alpha, (double *)dA(i,0),     &lda,
                                                  (double *)dB(i,0),     &ldb,
                   (const double *)&cbeta, (double *)dC(ioff,di), &ldc);
        }

        blockoffset = 0;
    }

    blockoffset = offset % nb;
    alpha = MAGMA_D_CNJG( alpha );
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        iblock = (ioff / nb) / nmic;          // local block id
        idev   = (ioff / nb) % nmic;          // device with this block
        di     = iblock*nb + blockoffset;     // local index in parent matrix

        // C[i:n,i] += B[i:n,0] * A[i,0]'
        //printf( "dgemm  n=%4d, ib=%4d, k=%4d, i=%4d\n", n-i, ib, k, i );
        if (idev == my_id) {
            rows = n - i;
            dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &rows, &ib, &k,
                   (const double *)&alpha, (double *)dB(i,0),     &ldb,
                                                  (double *)dA(i,0),     &lda,
                   (const double *)&c_one, (double *)dC(ioff,di), &ldc);
        }
        blockoffset = 0;
    }
    
    #undef dA
    #undef dB
    #undef dC
}

//=========================================================================================
void call_dsyr2k_mmic(magma_mic_dsyr2k_mmic_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldb, ldc, aoff, boff, offset, nb, my_id, nmic;
    double alpha;
    double beta;
    double *a, *b, *c;

    uplo   = param.uplo;
    trans  = param.trans;
    n      = param.n;
    k      = param.k;
    alpha  = param.alpha;
    a      = (double *)param.a;
    lda    = param.lda;
    aoff   = param.aoff;
    b      = (double *)param.b;
    ldb    = param.ldb;
    boff   = param.boff;
    beta   = param.beta;
    c      = (double *)param.c;
    ldc    = param.ldc;
    offset = param.offset;
    nmic   = param.nmic;
    nb     = param.nb;
    my_id  = param.my_id;

    //printf("DSYR2K_MMIC: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo, trans, n, k, alpha, (off_t)a, lda, beta, (off_t)c, ldc);

    magmablas_dsyr2k_mmic(
        uplo, trans, n, k,
        alpha, a, lda, aoff,
        b, ldb, boff,
        beta, c, ldc, offset,
        nmic, nb, my_id);
}

//=========================================================================================
void call_dlarft(magma_mic_dlarft_param param)
{
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t n, k, ldv, ldt;
    double *v, *tau, *t;
    
    direct = param.direct;
    storev = param.storev;
    n      = param.n;
    k      = param.k;
    v      = (double *)param.v;
    ldv    = param.ldv;
    tau    = (double *)param.tau;
    t      = (double *)param.t;
    ldt    = param.ldt;
    
    //printf("DLARFT: %c %c %d %d 0x%lx %d ox%lx 0x%lx %d\n", direct, storev, n, k, (off_t)v, ldv, (off_t)tau, (off_t)t, ldt);
    
    dlarft( lapack_const(direct), lapack_const(storev),
            &n, &k, (double *)v, &ldv,
            (double *)tau, (double *)t, &ldt);
}

//=========================================================================================
void call_dlarfb(magma_mic_dlarfb_param param)
{
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m, n, k, ldv, ldt, ldc, ldwork;
    double *v, *t, *c, *work;

    side   = param.side;
    trans  = param.trans;
    direct = param.direct;
    storev = param.storev;
    m      = param.m;
    n      = param.n;
    k      = param.k;
    v      = (double *)param.v;
    ldv    = param.ldv;
    t      = (double *)param.t;
    ldt    = param.ldt;
    c      = (double *)param.c;
    ldc    = param.ldc;
    work   = (double *)param.work;
    ldwork = param.ldwork;

    dlarfb( lapack_const(side), lapack_const(trans), lapack_const(direct), lapack_const(storev),
            &m, &n, &k, (double *)v, &ldv, (double *)t, &ldt,
            (double *)c, &ldc, (double *)work, &ldwork);
}

//=========================================================================================
//magmablas our DLARFB based on GEMMs Azzam
//=========================================================================================
void call_dlarfb_gemm(magma_mic_dlarfb_gemm_param param)
{
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m, n, k, ldv, ldt, ldc, ldwork, ldworkvt;
    double *v, *t, *c, *work, *workvt;
    
    side     = param.side;
    trans    = param.trans;
    direct   = param.direct;
    storev   = param.storev;
    m        = param.m;
    n        = param.n;
    k        = param.k;
    v        = (double *)param.v;
    ldv      = param.ldv;
    t        = (double *)param.t;
    ldt      = param.ldt;
    c        = (double *)param.c;
    ldc      = param.ldc;
    work     = (double *)param.work;
    ldwork   = param.ldwork;
    workvt   = (double *)param.workvt;
    ldworkvt = param.ldworkvt;
    
    double c_zero    = MAGMA_D_ZERO;
    double c_one     = MAGMA_D_ONE;
    double c_neg_one = MAGMA_D_NEG_ONE;

    /* Function Body */
    if (m <= 0 || n <= 0) {
        return;
    }

    // opposite of trans
    magma_trans_t transt;
    if (trans == MagmaNoTrans)
        transt = MagmaConjTrans;
    else
        transt = MagmaNoTrans;
    
    // whether T is upper or lower triangular
    magma_uplo_t uplo;
    if (direct == MagmaForward)
        uplo = MagmaUpper;
    else
        uplo = MagmaLower;
    
    // whether V is stored transposed or not
    magma_int_t notransV, transV;
    if (storev == MagmaColumnwise) {
        notransV = MagmaNoTrans;
        transV   = MagmaConjTrans;
    }
    else {
        notransV = MagmaConjTrans;
        transV   = MagmaNoTrans;
    }

    if ( side == MagmaLeft ) {
        // Form H C or H' C
        // Comments assume H C.
        // When forming H' C, T gets transposed via transt for m >= n or by trans for m < n.
        
        // W = C' V
        dgemm( lapack_const(MagmaConjTrans), lapack_const(notransV),
               &n, &k, &m,
               (const double *)&c_one,  (double *)c,    &ldc,
                                               (double *)v,    &ldv,
               (const double *)&c_zero, (double *)work, &ldwork);

        if (m < n) {
            // W2 = V T
            dgemm( lapack_const(notransV), lapack_const(trans),
                   &m, &k, &k,
                   (const double *)&c_one,  (double *)v,      &ldv,
                                                   (double *)t,      &ldt,
                   (const double *)&c_zero, (double *)workvt, &ldworkvt);
                        
            // C = C - W2 W' = C - V T V' C = (I - V T V') C = H C
            dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans),
                   &m, &n, &k,
                   (const double *)&c_neg_one, (double *)workvt, &ldworkvt,
                                                      (double *)work,   &ldwork,
                   (const double *)&c_one,     (double *)c,      &ldc);
        } else {
            // W2 = W T' = C' V T'
            dgemm( lapack_const(MagmaNoTrans), lapack_const(transt),
                   &n, &k, &k,
                   (const double *)&c_one,  (double *)work,   &ldwork,
                                                   (double *)t,      &ldt,
                   (const double *)&c_zero, (double *)workvt, &ldworkvt);
                                                 
            // C = C - V W2' = C - V T V' C = (I - V T V') C = H C
            dgemm( lapack_const(notransV), lapack_const(MagmaConjTrans),
                   &m, &n, &k,
                   (const double *)&c_neg_one, (double *)v,      &ldv,
                                                      (double *)workvt, &ldworkvt,
                   (const double *)&c_one,     (double *)c,      &ldc);
        }
    }
    else {
        // Form C H or C H'
        // Comments assume C H.
        // When forming C H', T gets transposed via trans.
        
        // W = C V
        dgemm( lapack_const(MagmaNoTrans), lapack_const(notransV),
               &m, &k, &n,
               (const double *)&c_one,  (double *)c,    &ldc,
                                               (double *)v,    &ldv,
               (const double *)&c_zero, (double *)work, &ldwork);
        if (m <= n) {
            // W2 = W T = C V T
            dgemm( lapack_const(MagmaNoTrans), lapack_const(trans),
                   &m, &k, &k,
                   (const double *)&c_one,  (double *)work,   &ldwork,
                                                   (double *)t,      &ldt,
                   (const double *)&c_zero, (double *)workvt, &ldworkvt);
            
            // C = C - W2 V' = C - C V T V' = C (I - V T V') = C H
            dgemm( lapack_const(MagmaNoTrans), lapack_const(transV),
                   &m, &n, &k,
                   (const double *)&c_neg_one, (double *)work, &ldwork,
                                                      (double *)v,    &ldv,
                   (const double *)&c_one,     (double *)c,    &ldc);
        } else {
            // W2 = T V'
            dgemm( lapack_const(trans), lapack_const(transV),
                   &k, &n, &k,
                   (const double *)&c_one,  (double *)t,      &ldt,
                                                   (double *)v,      &ldv,
                   (const double *)&c_zero, (double *)workvt, &ldworkvt);
            // C = C - W W2 = C - C V T V' = C (I - V T V') = C H
            dgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaNoTrans),
                   &m, &n, &k,
                   (const double *)&c_neg_one, (double *)work,   &ldwork,
                                                      (double *)workvt, &ldworkvt,
                   (const double *)&c_one,     (double *)c,      &ldc);
        }
    }
}

//=========================================================================================
void call_dlaset(magma_mic_dlaset_param param)
{
    magma_uplo_t uplo;
    magma_int_t m, n, lda;
    double alpha, beta;
    double *dA;

    uplo  = param.uplo;
    m     = param.m;
    n     = param.n;
    alpha = param.alpha;
    beta  = param.beta;
    dA    = (double *)param.dA;
    lda   = param.lda;

    dlaset( lapack_const(uplo), &m, &n,
            (const double *)&alpha, (const double *)&beta,
            (double *)dA, &lda);
}

//=========================================================================================
void call_dtranspose(magma_mic_dtranspose_param param)
{
        /******************************************************
         * _mm512_load_pd -- for loading
         * _mm512_i32lo[ext]scatter_pd
         * _mm512_i32loscatter_pd is the simplified version of ...ext...
         * they do the same thing, the latter needs less arguments.
         * **************************************************/
        //        printf("entered stranpose\n");
        //        fflush(stdout);
        /*
           double *odata, *idata;
           magma_int_t ldo,ldi, m, n;
           magma_int_t num_threads;
           magma_int_t tid;
           magma_int_t index[16], i;
           __M512D _reg;
           __m512i _index;
           double *my_head, *loop_head, *dest_head;
           magma_int_t num_cols, num_cols_g, col, iter, num_iter, num_rows_g, num_rows;

           odata = (double *) param.odata;
           ldo   = param.ldo;
           idata = (double *) param.idata;
           ldi   = param.ldi;
           m     = param.m;
           n     = param.n;

           if (m == 0 || n == 0) {
           return;
           }
           if (m <= n) {
           for (i = 0; i < 16; i++) {
           index[i] = i*DREG_WIDTH*ldo;
           }
        // 62 cores, 4 hardware threads per core. Leave out one core for the OS
        // (62 - 1)*4 = 244

        num_threads = 244;
        num_cols_g =        (n + num_threads - 1)/num_threads;
        num_iter = (int) m*1.0/DREG_WIDTH;
        _index = _mm512_set_epi32(index[15], index[14], index[13], index[12],
        index[11], index[10], index[9], index[8], index[7], index[6],
        index[5], index[4], index[3], index[2], index[1], index[0]);

#pragma omp parallel num_threads(num_threads) private(tid, col, num_cols, iter,\
my_head, loop_head, dest_head, _reg)
{
tid = omp_get_thread_num();
num_cols = num_cols_g;
if (tid == (num_threads - 1) && (n%num_cols_g != 0)) {
num_cols = n%num_cols_g;
}
// starting point of my section, constant for each thread
my_head = idata + ldi*(tid*num_cols_g);
for (iter = 0; iter < num_iter; iter++) { // loop inside each column
for (col = 0; col < num_cols; col++) { // loop over each column
if (tid*num_cols_g + col < n) {
        // starting point of the inner loop
        loop_head = my_head + col*ldi + iter*DREG_WIDTH;
        dest_head = odata + (iter*DREG_WIDTH)*ldo + (tid*num_cols_g + col);
        // load 8 double precision floating point nubmers from address
        // mt into a float64 vector.
        _reg = _MM512_LOAD_PPD( (void const *)loop_head);
        //                                        _mm512_load_pd( (void const *)loop_head);

        // this intrinsic needs int32 indices, but a 512 register
        // contains 16 int32 integers, and there is only one intrinsic
        // to set all 16 positoins of the register. So _index contains
        // 16 int32 integers.
        _MM512_I32LOEXTSCATTER_PPD((void *) dest_head, _index, _reg,
        _MM_DOWNCONV_PD_NONE, 1, _MM_HINT_NONE);
        }
        }
        }
        }
        } else {
        // init index[], it's for scattering the entries to the dest matrix
        for (i = 0; i < 16; i++) {
        index[i] = i*DREG_WIDTH*ldo;
        }

        // 62 cores, 4 hardware threads per core. Leave out one core for the OS
        // (62 - 1)*4 = 244
        num_threads = 244;
        // number of rows in each group
        num_rows_g = (m/DREG_WIDTH + num_threads - 1)/num_threads*DREG_WIDTH;
        _index = _mm512_set_epi32(index[15], index[14], index[13], index[12],
                        index[11], index[10], index[9], index[8], index[7], index[6],
                        index[5], index[4], index[3], index[2], index[1], index[0]);

#pragma omp parallel num_threads(num_threads) private(tid, col, num_rows, iter,\
                loop_head, dest_head, _reg, num_iter)
        {
                tid = omp_get_thread_num();
                // compute the number of rows I need to work on
                num_rows = num_rows_g;
                if (tid == (num_threads - 1) && (m%num_rows_g != 0)) {
                        num_rows = m%num_rows_g;
                }
                num_iter = (int) num_rows*1.0/DREG_WIDTH;

                for (iter = 0; iter < num_iter; iter++) {
                        if (tid*num_rows_g + iter*DREG_WIDTH < m) {
                                for (col = 0; col < n; col++) {
                                        loop_head = idata + (tid*num_rows_g + iter*DREG_WIDTH) + ldi*col;
                                        dest_head = odata + ldo*(tid*num_rows_g + iter*DREG_WIDTH) + col;

                                        _reg = _MM512_LOAD_PPD((void const *) loop_head);
                                        _MM512_I32LOEXTSCATTER_PPD((void *) dest_head, _index, _reg,
                                                        _MM_DOWNCONV_PD_NONE, 1, _MM_HINT_NONE);
                                }
                        }
                }
        }
}
*/
return;
}

//=========================================================================================
void call_dtranspose_mkl(magma_mic_dtranspose_param param)
{
    double *odata, *idata;
    magma_int_t ldo,ldi, m, n;
    magma_int_t num_threads;
    magma_int_t tid;
    magma_int_t index[16], i;
    //  _M512 _reg;
    //  _M512I _index;
    double *my_head, *loop_head, *dest_head;
    magma_int_t num_cols, num_cols_g, col, iter, num_iter;
    
    odata = (double *) param.odata;
    ldo   = param.ldo;
    idata = (double *) param.idata;
    ldi   = param.ldi;
    m     = param.m;
    n     = param.n;
    double c_one = MAGMA_D_ONE;
    
    mkl_domatcopy('C', 'T', m, n, *((double *)(&c_one)), (double *)idata, ldi,
                    (double *)odata, ldo);
}

//=========================================================================================
void call_dlaswp(magma_mic_dlaswp_param param)
{
    magma_int_t n, k1, k2, lda, incx;
    double *d_A;
    magma_int_t *d_ipiv;
                     
    n      = param.n;
    d_A    = (double *) param.d_A;
    lda    = param.lda;
    k1     = param.k1;
    k2     = param.k2;
    d_ipiv = (magma_int_t *) param.d_ipiv;
    incx   = param.incx;
    
    //printf("n: %d lda: %d k1: %d k2: %d incx: %d\n", n, lda, k1, k2, incx);
    dlaswp(&n, (double *)d_A, &lda, &k1, &k2, (magma_int_t *)d_ipiv, &incx);
}

//=========================================================================================
void call_dswap(magma_mic_dswap_param param)
{
    magma_int_t n, lda1, lda2;
    double tmp, *dA1T, *dA2T;
                     
    n       = param.n;
    dA1T    = (double *) param.dA1T;
    lda1    = param.lda1;
    dA2T    = (double *) param.dA2T;
    lda2    = param.lda2;
    
    dswap(&n, (double *)dA1T, &lda1, (double *)dA2T, &lda2);
}

//=========================================================================================
void call_dtrsmgemm(magma_mic_dtrsmgemm_param param)
{
    double gtrsmflops, ggemmflops, mic_trsmtime, mic_gemmtime;

    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t ttransa;
    magma_diag_t diag;
    magma_int_t tm, tn, tlda, tldb;
    double talpha, *ta, *tb;

    side    = param.trsm_param.side;
    uplo    = param.trsm_param.uplo;
    ttransa = param.trsm_param.transa;
    diag    = param.trsm_param.diag;
    tm      = param.trsm_param.m;
    tn      = param.trsm_param.n;
    talpha  = param.trsm_param.alpha;
    ta      = (double *)param.trsm_param.a;
    tlda    = param.trsm_param.lda;
    tb      = (double *)param.trsm_param.b;
    tldb    = param.trsm_param.ldb;

    mic_trsmtime = dsecnd();

    dtrsm( lapack_const(side), lapack_const(uplo), lapack_const(ttransa), lapack_const(diag),
           &tm, &tn, (const double *)&talpha, (double *)ta, &tlda,
           (double *)tb, &tldb);

    mic_trsmtime = dsecnd() - mic_trsmtime;

    gtrsmflops = 0;
    if (side == MagmaLeft)
        gtrsmflops = MICFLOPS_TRSM_L((double)tm, (double)tn) * 1e-9;
    else if (side == MagmaRight)
        gtrsmflops = MICFLOPS_TRSM_R((double)tm, (double)tn) * 1e-9;

    magma_trans_t transa, transb;
    magma_int_t m, n, k, lda, ldb, ldc;
    double alpha, beta, *a, *b, *c;

    transa = param.gemm_param.transa;
    transb = param.gemm_param.transb;
    m      = param.gemm_param.m;
    n      = param.gemm_param.n;
    k      = param.gemm_param.k;
    alpha  = param.gemm_param.alpha;
    a      = (double *)param.gemm_param.a;
    lda    = param.gemm_param.lda;
    b      = (double *)param.gemm_param.b;
    ldb    = param.gemm_param.ldb;
    beta   = param.gemm_param.beta;
    c      = (double *)param.gemm_param.c;
    ldc    = param.gemm_param.ldc;

    //printf("DGEMM: %c %c %d %d %d %f 0x%lx %d 0x%lx %d %f 0x%lx %d\n", transa, transb, m, n, k, alpha, (off_t)a, lda, (off_t)b, ldb, beta, (off_t)c, ldc);

    mic_gemmtime = dsecnd();

    dgemm( lapack_const(transa), lapack_const(transb),
           &m, &n, &k, (const double *)&alpha, (double *)a, &lda,
           (double *)b, &ldb, (const double *)&beta,
           (double *)c, &ldc);

    mic_gemmtime = dsecnd() - mic_gemmtime;

    ggemmflops = MICFLOPS_GEMM((double)m, (double)n, (double)k) * 1e-9;

    //printf("DTRSMGEMM: %8.4lf( %8.4lf )\t %8.4lf( %8.4lf )\n", gtrsmflops / mic_trsmtime, mic_trsmtime * 1000, ggemmflops / mic_gemmtime, mic_gemmtime * 1000);
}

//=========================================================================================


//=========================================================================================
void call_dlange(magma_mic_dlange_param param)
{

    magma_norm_t                    norm;
    magma_int_t                     m;
    magma_int_t                     n;
    magmaDouble_const_ptr    dA; 
    magma_int_t                     ldda;
    magmaDouble_ptr                 dwork;
    double                          *ret;

    norm    =  param.norm;   
    m       =  param.m;    
    n       =  param.n;    
    dA      =  param.dA;   
    ldda    =  param.ldda;      
    dwork   =  param.dwork;
    ret     =  param.ret;

    *ret = dlange( lapack_const(norm), &m, &n,
            (double *)dA, &ldda, (double*) dwork);

}

//=========================================================================================

//=========================================================================================
void call_dlacpy(magma_mic_dlacpy_param param)
{
    magma_uplo_t                    uplo;
    magma_int_t                     m;
    magma_int_t                     n;
    magmaDouble_const_ptr    dA;
    magma_int_t                     ldda;
    magmaDouble_ptr          dB;
    magma_int_t                     lddb;

    uplo    =  param.uplo           ;
    m       =  param.m              ;
    n       =  param.n              ;
    dA      =  param.dA             ;
    ldda    =  param.ldda           ;
    dB      =  param.dB             ;
    lddb    =  param.lddb           ;

    
    // More testing is needed to determine the best version:
    // around 50 GB/s; ~70 with env MIC_OMP_NUM_THREADS=60 MIC_KMP_AFFINITY=scatter
    /*
    dlacpy( lapack_const(uplo), &m, &n,
            (double *)dA, &ldda,
            (double *)dB, &lddb );
    */
#if 1
    if (uplo == MagmaLower || uplo == MagmaUpper) {
        dlacpy( lapack_const(uplo), &m, &n,
                (double *)dA, &ldda,
                (double *)dB, &lddb );
    }
    else {
        // around 95 GB/s
        magma_int_t ix=0, iy=0;
        #pragma omp parallel for
        for (magma_int_t i=0; i < n; i++) {
            memcpy(dB + i*lddb, dA + i*ldda, m*sizeof(double));
        }
        
        /*
        // version 1: around 99 GB/s; 
        // with -opt-prefetch-distance=64,8 -opt-streaming-cache-evict=0 -opt-streaming-stores always
        // and 64 threads scatter gets to 150 GB/s
        magma_int_t ix=0, iy=0;
        #pragma omp parallel for
        for (magma_int_t i=0; i < n*m; i++) {
            int j = i%m, ii = i/m;
            dB[j+ii*lddb] = dA[j+ii*ldda];
        } 
        */
        /*
        // version 2
        #pragma omp parallel for collapse(2)
        for (magma_int_t i=0; i < n; i++) {
            for(int j =0; j<m; j++)
                dB[j+i*lddb] = dA[j+i*ldda];
        }
        */
    }
#endif
}

//=========================================================================================

//=========================================================================================
void call_idamax(magma_mic_idamax_param param)
{   
    magma_int_t                     n;
    magmaDouble_const_ptr    dx;
    magma_int_t                     incx;
    magma_int_t                    *ret;

    n       =  param.n              ;
    dx      =  param.dx             ;
    incx    =  param.incx           ;
    ret     =  param.ret            ;
    *ret = idamax(  &n,
                    (double *)dx, &incx );
}

//=========================================================================================
//=========================================================================================

void daxpycp2( magma_int_t m, magmaDouble_ptr r, magmaDouble_ptr x,magmaDouble_ptr b)
{
#pragma omp parallel for
    for ( int i = 0; i < m; i++ ) {
        x[i] = MAGMA_D_ADD( x[i], r[i] );
        r[i] = b[i];
    }
}

void call_daxpycp2(magma_mic_daxpycp2_param param)
{


    
    magma_int_t                     m;
    double    *r;
    double    *x;
    double    *b;

    m       =  param.m              ;
    r       =  param.r              ;
    x       =  param.x              ;
    b       =  param.b              ;

    daxpycp2( m ,r, x, b);
}

//=========================================================================================

