/*
 *   -- micMAGMA (version 1.4.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 *   @generated from magma_zc_kernels.h mixed zc -> ds, Sun Jul 12 17:46:28 2015
 *
 *   This is included in magma_mic_server.cpp,
 *   inside a switch { } block in the do_work() function.
 */

case magma_mic_DSAXPYCP:
{
    magma_mic_dsaxpycp_param param;
    if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
        printf("scif_recv failed for DSAXPYCP\n");
        return;
    }

    mic_time = dsecnd();
    #pragma omp parallel for schedule(static,48)
    for (int i=0; i<param.m; i++){
        param.x[i] += param.r[i];
        param.w[i]  = param.b[i];
    }

    mic_time = dsecnd() - mic_time;

    break;
}

case magma_mic_DLAG2S:
{
    magma_mic_dlag2s_param param;
    if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
        printf("scif_recv failed for DLAG2S\n");
        return;
    }
    
    mic_time = dsecnd();
    call_dlag2s(param);
    mic_time = dsecnd() - mic_time;
    
    break;
}

case magma_mic_DLAT2S:
 {
     magma_int_t info;
     magma_mic_dlat2s_param param;
     if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
         printf("scif_recv failed for DLAT2S\n");
         return;
     }

     mic_time = dsecnd();
     dlat2s(lapack_uplo_const(param.uplo), &param.n, 
            (double *)param.dA, &param.lda, 
            (float *)param.dAs, &param.ldas, &info);
     mic_time = dsecnd() - mic_time;

     break;
 }

case magma_mic_SLAG2D:
{
    magma_mic_slag2d_param param;
    if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
        printf("scif_recv failed for SLAG2D\n");
        return;
    }
    
    mic_time = dsecnd();
    call_slag2d(param);
    mic_time = dsecnd() - mic_time;
    
    break;
}


case magma_mic_DSGESV:
{
    magma_mic_dsgesv_param param;
    if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
        printf("scif_recv failed for DSGESV\n");
        return;
    }
    
    mic_time = dsecnd();
    call_dsgesv(param);
    mic_time = dsecnd() - mic_time;
    
    break;
}
