/*
    -- MAGMA (version 1.4.0) --
       Univ. of Tennessee, Knoxville
       Univ. of California, Berkeley
       Univ. of Colorado, Denver
       November 2011
*/

#ifndef MAGMASPARSE_DEV_TYPES_H
#define MAGMASPARSE_DEV_TYPES_H


#ifdef __cplusplus
extern "C" {
#endif




typedef struct magma_z_sparse_matrix_dev{

    magma_storage_t    storage_type;
    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        num_cols; 
    magma_int_t        nnz; 
    magma_int_t        max_nnz_row;
    magma_int_t        diameter;
    magmaDoubleComplex_ptr    val;
    magmaInt_ptr    row; 
    magmaInt_ptr    col;
    magma_int_t        *blockinfo;
    magma_int_t        blocksize;
    magma_int_t        numblocks;

}magma_z_sparse_matrix_dev;

typedef struct magma_c_sparse_matrix_dev{

    magma_storage_t    storage_type;
    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        num_cols; 
    magma_int_t        nnz; 
    magma_int_t        max_nnz_row;
    magma_int_t        diameter;
    magmaFloatComplex_ptr     val;
    magmaInt_ptr     row; 
    magmaInt_ptr     col;
    magma_int_t        *blockinfo;
    magma_int_t        blocksize;
    magma_int_t        numblocks;

}magma_c_sparse_matrix_dev;


typedef struct magma_d_sparse_matrix_dev{

    magma_storage_t    storage_type;
    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        num_cols; 
    magma_int_t        nnz; 
    magma_int_t        max_nnz_row;
    magma_int_t        diameter;
    magmaDouble_ptr    val;
    magmaInt_ptr    row; 
    magmaInt_ptr    col;
    magma_int_t        *blockinfo;
    magma_int_t        blocksize;
    magma_int_t        numblocks;

}magma_d_sparse_matrix_dev;


typedef struct magma_s_sparse_matrix_dev{

    magma_storage_t    storage_type;
    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        num_cols; 
    magma_int_t        nnz; 
    magma_int_t        max_nnz_row;
    magma_int_t        diameter;
    magmaFloat_ptr     val;
    magmaInt_ptr     row; 
    magmaInt_ptr     col;
    magma_int_t        *blockinfo;
    magma_int_t        blocksize;
    magma_int_t        numblocks;

}magma_s_sparse_matrix_dev;



typedef struct magma_z_vector_dev{

    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        nnz; 
    magmaDoubleComplex_ptr     val;

}magma_z_vector_dev;

typedef struct magma_c_vector_dev{

    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        nnz; 
    magmaFloatComplex_ptr     val;

}magma_c_vector_dev;


typedef struct magma_d_vector_dev{

    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        nnz; 
    magmaDouble_ptr     val;

}magma_d_vector_dev;


typedef struct magma_s_vector_dev{

    magma_location_t   memory_location;
    magma_int_t        num_rows;
    magma_int_t        nnz; 
    magmaFloat_ptr     val;

}magma_s_vector_dev;


#ifdef __cplusplus
}
#endif

#endif        //  #ifndef MAGMASPARSE_DEV_TYPES_H
