/*
    -- MAGMA (version 1.4.0) --
       Univ. of Tennessee, Knoxville
       Univ. of California, Berkeley
       Univ. of Colorado, Denver
       November 2011

       @generated ds Wed Nov 20 17:44:48 2013
       @author Hartwig Anzt
*/

#ifndef MAGMASPARSE_DS_H
#define MAGMASPARSE_DS_H

#include "magma_types.h"
#include "magmasparse_types.h"

#define PRECISION_d


/* ////////////////////////////////////////////////////////////////////////////
   -- MAGMA_SPARSE Matrix Descriptors
*/


#ifdef __cplusplus
extern "C" {
#endif

/* ////////////////////////////////////////////////////////////////////////////
   -- MAGMA_SPARSE Auxiliary functions
*/
magma_int_t
magma_vector_dlag2s(                magma_d_vector x, 
                                    magma_s_vector *y );

magma_int_t
magma_sparse_matrix_dlag2s(         magma_d_sparse_matrix A, 
                                    magma_s_sparse_matrix *B );


magma_int_t
magma_vector_slag2d(                magma_s_vector x, 
                                    magma_d_vector *y );

magma_int_t
magma_sparse_matrix_slag2d(         magma_s_sparse_matrix A, 
                                    magma_d_sparse_matrix *B );

void
magmablas_dlag2s_sparse(            magma_int_t M, magma_int_t N , 
                                    const double *A, magma_int_t lda, 
                                    float *SA, magma_int_t ldsa, 
                                    magma_int_t *info );

void 
magmablas_slag2d_sparse(            magma_int_t M, magma_int_t N , 
                                    const float *SA, magma_int_t ldsa, 
                                    double *A, magma_int_t lda, 
                                    magma_int_t *info );

void 
magma_dlag2s_CSR_DENSE(             magma_d_sparse_matrix A, 
                                    magma_s_sparse_matrix *B );

void 
magma_dlag2s_CSR_DENSE_alloc(       magma_d_sparse_matrix A, 
                                    magma_s_sparse_matrix *B );

void 
magma_dlag2s_CSR_DENSE_convert(     magma_d_sparse_matrix A, 
                                    magma_s_sparse_matrix *B );

/* ////////////////////////////////////////////////////////////////////////////
   -- MAGMA_SPARSE function definitions / Data on CPU
*/


/* ////////////////////////////////////////////////////////////////////////////
   -- MAGMA_SPARSE function definitions / Data on CPU / Multi-GPU
*/

/* ////////////////////////////////////////////////////////////////////////////
   -- MAGMA_SPARSE function definitions / Data on GPU
*/
magma_int_t
magma_dspgmres(     magma_d_sparse_matrix A, magma_d_vector b, magma_d_vector *x,  
                    magma_solver_parameters *solver_par,  
                    magma_precond_parameters *precond_par);

magma_int_t
magma_dspbicgstab(  magma_d_sparse_matrix A, magma_d_vector b, magma_d_vector *x,  
                    magma_solver_parameters *solver_par,  
                    magma_precond_parameters *precond_par);

magma_int_t
magma_dsir(         magma_d_sparse_matrix A, magma_d_vector b, magma_d_vector *x,  
                    magma_solver_parameters *solver_par, 
                    magma_precond_parameters *precond_par );

magma_int_t
magma_dspir(        magma_d_sparse_matrix A, magma_d_vector b, magma_d_vector *x,  
                    magma_solver_parameters *solver_par, 
                    magma_precond_parameters *precond_par );


/* ////////////////////////////////////////////////////////////////////////////
   -- MAGMA_SPARSE utility function definitions
*/



/* ////////////////////////////////////////////////////////////////////////////
   -- MAGMA_SPARSE BLAS function definitions
*/



#ifdef __cplusplus
}
#endif

#undef PRECISION_d
#endif /* MAGMASPARSE_DS_H */
